;~ This file is part of ClipKeeper.

;~     ClipKeeper is free software: you can redistribute it and/or modify
;~     it under the terms of the GNU General Public License as published by
;~     the Free Software Foundation, either version 3 of the License, or
;~     (at your option) any later version.

;~     ClipKeeper is distributed in the hope that it will be useful,
;~     but WITHOUT ANY WARRANTY; without even the implied warranty of
;~     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;~     GNU General Public License for more details.

;~     You should have received a copy of the GNU General Public License
;~     along with ClipKeeper.  If not, see <http://www.gnu.org/licenses/>.

#include <APIGdiConstants.au3>
#include <APIResConstants.au3>
#include <ButtonConstants.au3>
#include <Clipboard.au3>
#include <Crypt.au3>
#include <EditConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <ScreenCapture.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <TrayConstants.au3>
#include <WinAPI.au3>
#include <WinAPIGdi.au3>
#include <WinAPISys.au3>
#include <WindowsConstants.au3>
#include "include\_Cursor.au3"
#include "include\_GUIRegisterMsg.au3"
#include "include\_GUIXViewEx.au3"
#include "include\_Inspect.au3"
#include "include\_Monitors.au3"
#include "include\AddIcon.au3"
#include "include\Bitmap.au3"
#include "include\Bitmap_String.au3"
#include "include\GetWorkArea.au3"
#include "include\GUICtrlOnHover.au3"
#include "include\MouseOnEvent.au3"
#include "include\SetBitmap.au3"
#include "include\StringSize.au3"
#include "include\SurveillerSouris.au3"
#include "include\WinAPIEx.au3"
#include "GPL.au3"

HotKeySet("^{PRINTSCREEN}", "InitTakeImpr")

If(Not(@Compiled)) Then
	Inspect_SetHotKey("{F7}")
EndIf

Opt("GuiOnEventMode", 1)
Opt("MustDeclareVars", 1)
Opt("TrayMenuMode",3)
Opt("TrayAutoPause", 0)
Opt("TrayOnEventMode",1)
Opt("GUIDataSeparatorChar", "")

HotKeySet("^", "quit")

Global $titre = "Clip Keeper"
Global $version = "1.6.14"
Global $anneeDebut = "2010"
Global $anneeDerniereModif = "2015"
Global $prenomDev = "Tom"
Global $nomDev = "Barthlmy"
Global $pseudo = "TommyDDR"
Global $mail = "tom_lyo@hotmail.fr"
Global $site = "http://tombarthelemy.fr"
Global $siteDon = "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=FCAS4AKC9R7MG"
Global $gNU_GPL = GetGNU_GPL()
Global $remerciements = GetRemerciements()
Global $imageSaveNameCount = 0
;~ Global $zoom = RegRead("HKEY_CURRENT_USER\Control Panel\Desktop", "LogPixels")*25/2400
;~ ConsoleWrite($zoom & @CRLF)

If _Singleton("ClipKeeper31415926535", 1) = 0 Then
    MsgBox(0, "Erreur", $titre & " est dj lanc.")
    Exit
EndIf

_GDIPlus_Startup()
OnAutoItExitRegister("exit_FreeWindowsRessources")
OnAutoItExitRegister("exit_gdiplus")

Global $gui
Global $guiDetail
Global $guiOptions
Global $guiExemple
Global $guiRaccourcis
Global $guiRaccourcisAlternatifs
Global $guiImpr[5]
Global $ctrlImpr
Global $trans = 0xF8F8F8
Global $guiEasterEgg
Global $mPosTakeImpr1[2]
Global $mPosTakeImpr3[4]
Global $oldMPos[2]					= [-1, -1]
Global $oldShowDetails				= False
Global $etatTakeImpr				= -1
Global $etatColorPickUp				= -1
Global $etatRaccourciAlt			= -1
Global $oldPosRaccAlt[2]			= [-1, -1]
Global $colorPickUp_Col[2]
Global $colorPickUp_OldPos[2]
Global $listView
Global $exemple_ListView
Global $exemple_Items[4]
Global $fleche
Global $exemple_Fleche
Global $details[3][2]
Global $detailAffiche				= 0
Global $clip[1][10]
Global $options_Slide
Global $options_molette
Global $options_Ok
Global $options_Defaut
Global $options_Appliquer
Global $options_Annuler
Global $options_Tab
Global $options_FaireUnDon[2]
Global $options_Edit[6][2]
Global $options_CouleurPreview
Global $options_TakeImpr
Global $options_BoutonTakeImpr
Global $options_PicPreview
Global $options_Pipette
Global $options_Sensibilite_Def		= 1
Global $options_Sensibilite			= -1
Global $options_SensibiliteTemp		= -1
Global $options_TitreClip_Def		= "%UserName%'s clipboard"
Global $options_TitreClip			= $options_TitreClip_Def
Global $options_TitreClipTemp		= $options_TitreClip_Def
Global $options_ReduceSize_Def		= 0
Global $options_ReduceSize			= $options_ReduceSize_Def
Global $sensMolette					= 1
Global $police						= "Tahoma"
Global $nbScroll					= 0
Global $nbScrollMax					= 1
Global $cacheIfShow					= False
Global $show						= False
Global $showDetails					= False
Global $showOptions					= False
Global $okNext						= True
Global $showMe						= False
Global $posMouse[2]
Global $posCkBig[2]					= [0, 60]
Global $easterEgg
Global $easterEggStep				= 1
Global $posEasterEgg[2]
Global $posEasterEggAnim[2]
Global $indiceEasterEgg				= 0
Global $timerEasterEgg				= 0
Global $etatEasterEgg				= -1
Global $nbClip						= 0
Global $positionFleche				= -1
;~ Global $tailleBase					= 26
;~ Global $tailleParClip				= 17
Global $tailleBase					= 0
Global $tailleParClip				= 0
Global $side
Global $espaceDebut					= 15
Global $rectif						= 3
Global $tailleFenetreX				= 250
Global $couleur_FondSelect_Def		= 0xFFDEFF
Global $couleur_TexteSelect_Def		= 0x000000
Global $couleur_FondAutre_Def		= 0xFFFFFF
Global $couleur_TexteAutre_Def		= 0x000000
Global $couleur_FondSelect			= -1
Global $couleur_TexteSelect			= -1
Global $couleur_FondAutre			= -1
Global $couleur_TexteAutre			= -1
Global $couleur_FondSelectTemp		= -1
Global $couleur_TexteSelectTemp		= -1
Global $couleur_FondAutreTemp 		= -1
Global $couleur_TexteAutreTemp		= -1
Global $nbImages					= 0
Global $nbMaxElements				= 0
Global $preShow						= False
Global $pause						= False
Global $showAfterImpr				= False
Global $tailleFenetreDetailDef[2]	= [300, 200]
Global $tailleFenetreDetail[2]		= [300, 200]
Global $tailleFenetreImprOptions[2]	= [220, 150]
Global $sideFenetreDetail[2]
Global $sideFenetreMain[2]
Global $ASCII2						= StringLeft(BinaryToString(2), 1)
Global $ASCII1						= StringLeft(BinaryToString(1), 1)
Global $NULL						= StringLeft(BinaryToString(0), 1)
Global $etat[5]						= [False, False, False, False, False]
Global $aideTouches[10][3]			= [	["Ctrl" & $ASCII1 & "Ctrl",						"",														False], _
										["Ctrl" & $ASCII1 & "Haut",						"Molette Haut",											True], _
										["Ctrl" & $ASCII1 & "Bas",						"Molette Bas",											True], _
										["Ctrl" & $ASCII1 & "Enter",					"Ctrl" & $ASCII1 & "v",									True], _
										["Ctrl" & $ASCII1 & "Suppr",					"Ctrl" & $ASCII1 & "Clic Molette",						True], _
										["Ctrl" & $ASCII1 & "Maj" & $ASCII1 & "Suppr",	"Ctrl" & $ASCII1 & "Maj" & $ASCII1 & "Clic Molette",	True], _
										["Ctrl" & $ASCII1 & "Windows",					"",														True], _
										["Ctrl" & $ASCII1 & "Maj" & $ASCII1 & "Windows","",														True], _
										["Ctrl" & $ASCII1 & "Droite",					"Ctrl" & $ASCII1 & "Souris Droite",						True], _
										["Ctrl" & $ASCII1 & "Gauche",					"Ctrl" & $ASCII1 & "Souris Gauche",						True]]
Global $aidePhrases[UBound($aideTouches, 1)] = _
									[	"Affiche la fentre " & $titre, _
										"Slectionne l'item au dessus", _
										"Slectionne l'item en dessous", _
										"Colle un lment", _
										"Supprime un lment", _
										"Supprime tous les lments", _
										"(D)verrouille un lment", _
										"(D)verrouille tous les lments", _
										"Affiche les dtails", _
										"Cache les dtails"]
Global $ctrlIDAide[UBound($aideTouches, 1)][15]
Global $ctrlIDRaccAlt[14]
Global $trayMenu[5]
Global $clipGet
Global $addClip						= True
Global $transparence				= 200
Global $fichierConfig				= @ScriptDir & "\CKConf.ini"
Global $desktopArea					= GetWorkArea()
ReDim $desktopArea[6]
$desktopArea[4]						= $desktopArea[0]+$desktopArea[2]
$desktopArea[5]						= $desktopArea[1]+$desktopArea[3]
Global $desktopSize					= GetDesktopSize()
Global $magZoom						= 3
Global $magWidth					= 21 * $magZoom
Global $magHeight					= 21 * $magZoom
Global $dll[2]

$dll[0] = DllOpen("user32.dll")
$dll[1] = DllOpen("gdi32.dll")

Global Const $GUI_DOCKDETAILS		= BitOR($GUI_DOCKLEFT, $GUI_DOCKTOP, $GUI_DOCKSIZE)

Global Const $DETAILS_IMAGE			= 0
Global Const $DETAILS_TEXTE			= 1
Global Const $DETAILS_COULEUR		= 2

Global Const $DETAILS_ID			= 0
Global Const $DETAILS_HASH			= 1


Global Const $CLIP_ID				= 0
Global Const $CLIP_TYPE				= 1
Global Const $CLIP_DATA				= 2
Global Const $CLIP_DATASHOW			= 3
Global Const $CLIP_CLIPTYPE			= 4
Global Const $CLIP_HASH				= 5
Global Const $CLIP_PROTECTION		= 6
Global Const $CLIP_IMGX				= 7
Global Const $CLIP_IMGY				= 8
Global Const $CLIP_PREVIEW			= 9

Global Const $DRAW_POSITION			= 0x01
Global Const $DRAW_TAILLE			= 0x02
Global Const $DRAW_FLECHE			= 0x04
Global Const $DRAW_ALL				= BitOR($DRAW_POSITION, $DRAW_TAILLE, $DRAW_FLECHE)

Global $KEY_WHEEL	= "04"
Global $KEY_LEFT	= "25"
Global $KEY_RIGHT	= "27"
Global $KEY_IMPR	= "2C"
;~ Global $KEY_SUPPR	= "2E"
Global $KEY_ENTER	= "0D"
Global $KEY_SHIFT	= "10"
Global $KEY_CTRL	= "11"
Global $KEY_C		= "43"
Global $KEY_V		= "56"
Global $KEY_X		= "58"
Global $KEY_WIN1	= "5B"
Global $KEY_WIN2	= "5C"

FileInstalls()

ChargerParams()

$trayMenu[0] = TrayCreateItem("Afficher " & $titre)
$trayMenu[1] = TrayCreateItem("Afficher dtails")
			   TrayCreateItem("")
$trayMenu[2] = TrayCreateItem("Options")
$trayMenu[3] = TrayCreateItem("Pause")
$trayMenu[4] = TrayCreateItem("Quitter")
TrayItemSetOnEvent($trayMenu[0], "Show")
TrayItemSetOnEvent($trayMenu[1], "ShowDetailsNC")
TrayItemSetOnEvent($trayMenu[2], "AffOptions")
TrayItemSetOnEvent($trayMenu[3], "pause")
TrayItemSetOnEvent($trayMenu[4], "quit")
TraySetOnEvent($TRAY_EVENT_PRIMARYDOWN, "CacheIfShowNC")
TraySetOnEvent($TRAY_EVENT_PRIMARYDOUBLE, "AffOptions")
TraySetIcon(@TempDir & "\Icon_ClipKeeper.ico")
TraySetToolTip($titre)

For $i = 0 To UBound($guiImpr, 1)-1
	If($i = 0) Then
		$guiImpr[$i] = GUICreate("", $desktopSize[2], $desktopSize[3], $desktopSize[0], $desktopSize[1], $WS_POPUP, BitOR($WS_EX_LAYERED, $WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
		GUISetBkColor(0x000000, $guiImpr[$i])
		WinSetTrans($guiImpr[$i], "", 80)
		_WinAPI_SetLayeredWindowAttributes($guiImpr[$i], $trans)
		WinSetTrans($guiImpr[$i], "", 80)
;~ 		_WinAPI_SetWindowLong($guiImpr[$i], $GWL_EXSTYLE, BitOR(_WinAPI_GetWindowLong($guiImpr[$i], $GWL_EXSTYLE), $WS_EX_TRANSPARENT))
 		$ctrlImpr = GUICtrlCreateLabel("", -10000, -10000, 1, 1)
		GUICtrlSetBkColor($ctrlImpr, $trans)
	Else
		$guiImpr[$i] = GUICreate("", 1, 1, -10000, -10000, $WS_POPUP, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
		GUISetBkColor(0xFF0000, $guiImpr[$i])
		WinSetTrans($guiImpr[$i], "", 180)
	EndIf
Next

InitVariables()

Local $tailleFenetreOptions[2] = [350, 420]
$posCkBig[0] = ($tailleFenetreOptions[0]-64)/2
$guiOptions					= GUICreate("Options", $tailleFenetreOptions[0], $tailleFenetreOptions[1]+3, $desktopArea[4]-$tailleFenetreOptions[0]-$side[0]*2, $desktopArea[5]-($tailleFenetreOptions[1]+3)-$side[0]-$side[1])
$guiExemple					= GUICreate($titre, $tailleFenetreX-2, $tailleBase+$tailleParClip-2, 50, 230, $WS_CHILD, -1, $guiOptions)
							  GUIFillMainWindow($guiExemple, $exemple_Fleche, $exemple_ListView, $options_TitreClip)
							  GUICtrlSetPos($exemple_Fleche, 5, $tailleBase+$tailleParClip*1-$rectif)
							  GUISetState(@SW_SHOWNA, $guiExemple)
$guiRaccourcis				= GUICreate("Raccourcis", $tailleFenetreOptions[0]-50, 1*($tailleFenetreOptions[1]-75)-30, 25, 50, $WS_CHILD, -1, $guiOptions)
							  GUISetBkColor(0xFCFCFE)
							  RemplirBoutonsAide()
							  GUISetState(@SW_SHOWNA, $guiRaccourcis)
							  GUISwitch($guiOptions)
							  GUISetIcon(@TempDir & "\Icon_ClipKeeper.ico", -1, $guiOptions)
							  GUISetOnEvent($GUI_EVENT_CLOSE, "AnnulerOptions", $guiOptions)
$options_Defaut				= GUICtrlCreateButton("Dfaut", 5, $tailleFenetreOptions[1]-25, ($tailleFenetreOptions[0]-10)/4-5, 23)
$options_Ok					= GUICtrlCreateButton("OK", 8+($tailleFenetreOptions[0]-15)/4, $tailleFenetreOptions[1]-25, ($tailleFenetreOptions[0]-10)/4-5, 23)
$options_Annuler			= GUICtrlCreateButton("Annuler", 10+2*($tailleFenetreOptions[0]-15)/4, $tailleFenetreOptions[1]-25, ($tailleFenetreOptions[0]-10)/4-5, 23)
$options_Appliquer			= GUICtrlCreateButton("Appliquer", 12+3*($tailleFenetreOptions[0]-15)/4, $tailleFenetreOptions[1]-25, ($tailleFenetreOptions[0]-10)/4-5, 23)

$options_Tab				= GUICtrlCreateTab(6, 6, $tailleFenetreOptions[0]-12, $tailleFenetreOptions[1]-34)

							  GUICtrlCreateTabItem("Outils")
							  GUICtrlCreateGroup("Color Picker", 20, 35, $tailleFenetreOptions[0]-40, 87)
							  GUICtrlCreateIcon(@TempDir & "\couleur.ico", -1, 30, 63, 35, 35)
$options_Edit[0][0]			= GUICtrlCreateInput("", 115, 70, 50, 20)
							  GUICtrlCreateLabel("Couleur", 70, 73, 40, 15)
$options_Pipette			= GUICtrlCreateIcon(@TempDir & "\col.ico", -1, 180, 73, 16, 16)
$options_CouleurPreview		= GUICtrlCreateLabel("", 200, 73, 16, 16, $SS_SUNKEN)
$options_PicPreview			= GUICtrlCreatePic("", 230, 50, $magWidth, $magHeight)
							  GUICtrlCreateGroup("Impression cran", 20, 130, $tailleFenetreOptions[0]-40, 180)
$options_BoutonTakeImpr		= GUICtrlCreateIcon(@TempDir & "\picture.ico", -1, 32, 160, 32, 32)
$options_TakeImpr			= GUICtrlCreatePic("", 80, 150, 220, 150)
							  GUICtrlCreateGroup("", -99, -99, 1, 1)

							  GUICtrlCreateTabItem("Gnral")
							  GUICtrlCreateGroup("Motion", 20, 35, $tailleFenetreOptions[0]-40, 1*($tailleFenetreOptions[1]-75)/4-5)
							  GUICtrlCreateLabel("Vitesse de la molette :", 70, 50, 110, 15)
$options_molette			= GUICtrlCreateLabel($options_Sensibilite, 180, 50, $tailleFenetreOptions[0]-280, 15)
							  GUICtrlCreateIcon(@TempDir & "\molette.ico", -1, 30, 60, 35, 35)
							  GUICtrlCreateLabel("Rapide", 70, 72, 35, 15)
$options_Slide				= GUICtrlCreateSlider(105, 70, $tailleFenetreOptions[0]-170, 20)
							  GUICtrlSetLimit($options_Slide, 10, 1)
							  GUICtrlSetData($options_Slide, $options_Sensibilite)
							  GUICtrlCreateLabel("Lent", 75+$tailleFenetreOptions[0]-140, 72, 35, 15)
							  GUICtrlCreateGroup("Interface", 20, 1*($tailleFenetreOptions[1]-75)/4+40, $tailleFenetreOptions[0]-40, 3*($tailleFenetreOptions[1]-75)/4-5)
							  GUICtrlCreateIcon(@TempDir & "\couleur.ico", -1, 30, 148, 35, 35)
							  GUICtrlCreateLabel("Sel (Fond)", 70, 150, 55, 15)
							  GUICtrlSetTip(-1, "Couleur de fond de l'item selectionn.")
$options_Edit[1][0]			= GUICtrlCreateInput(StringTrimLeft(Hex($couleur_FondSelect), 2), 125, 146, 50, 20)
							  GUICtrlCreateLabel("Sel (Texte)", 70, 168, 55, 15)
							  GUICtrlSetTip(-1, "Couleur du texte de l'item selectionn.")
$options_Edit[2][0]			= GUICtrlCreateInput(StringTrimLeft(Hex($couleur_TexteSelect), 2), 125, 165, 50, 20)
							  GUICtrlCreateLabel("Autre (Fond)", 180, 150, 65, 15)
							  GUICtrlSetTip(-1, "Couleur de fond des items non selectionns.")
$options_Edit[3][0]			= GUICtrlCreateInput(StringTrimLeft(Hex($couleur_FondAutre), 2), 249, 146, 50, 20)
							  GUICtrlCreateLabel("Autre (Texte)", 180, 168, 65, 15)
							  GUICtrlSetTip(-1, "Couleur du texte des items non selectionns.")
$options_Edit[4][0]			= GUICtrlCreateInput(StringTrimLeft(Hex($couleur_TexteAutre), 2), 249, 165, 50, 20)
							  GUICtrlCreateLabel("Titre", 70, 190, 65, 15)
							  GUICtrlSetTip(-1, "Titre de la fentre.")
$options_Edit[5][0]			= GUICtrlCreateInput($options_TitreClip, 125, 184, 174, 20)
							  GUICtrlCreateGroup("", -99, -99, 1, 1)

							  GUICtrlCreateTabItem("Raccourcis")
							  GUICtrlSetBkColor(-1, 0xFF0000)
 							  GUICtrlCreateGroup("Raccourcis", 20, 35, $tailleFenetreOptions[0]-40, 1*($tailleFenetreOptions[1]-75)-5)
							  GUICtrlCreateGroup("", -99, -99, 1, 1)

							  GUICtrlCreateTabItem("Licence")
 							  GUICtrlCreateGroup("GNU General Public Licence", 20, 35, $tailleFenetreOptions[0]-40, 1*($tailleFenetreOptions[1]-75)-5, $BS_CENTER)
							  GUICtrlCreateEdit($gNU_GPL, 25, 50, $tailleFenetreOptions[0]-50, 1*($tailleFenetreOptions[1]-75)-30, BitOR($ES_MULTILINE, $WS_VSCROLL, $ES_READONLY))
							  GUICtrlSetFont(-1, -1, -1, -1, "Courier New")
							  GUICtrlCreateGroup("", -99, -99, 1, 1)

							  GUICtrlCreateTabItem("A propos")
							  GUICtrlCreateGroup($titre & " v." & $version, 20, 35, $tailleFenetreOptions[0]-40, 2*($tailleFenetreOptions[1]-75)/4-5, $BS_CENTER)
$easterEgg					= GUICtrlCreateIcon(@TempDir & "\ckbig.ico", -1, $posCkBig[0], $posCkBig[1], 64, 64)
							  GUICtrlCreateLabel("Copyright  " & $anneeDebut & ", " & $anneeDerniereModif & " " & $prenomDev & " " & $nomDev & " (" & $pseudo & ")", 30, 130, $tailleFenetreOptions[0]-60, 15, $SS_CENTER)
							  GUICtrlCreateLabel($mail, 30, 145, $tailleFenetreOptions[0]-60, 15, $SS_CENTER)
							  GUICtrlSetColor(-1, 0x0000FF)
							  GUICtrlSetCursor(-1, 0)
							  GUICtrlSetOnEvent(-1, "MailTo")
							  GUICtrlCreateLabel("Dernire version, informations, sources, etc...", 30, 160, $tailleFenetreOptions[0]-60, 15, $SS_CENTER)
							  GUICtrlCreateLabel($site, 30, 175, $tailleFenetreOptions[0]-60, 15, $SS_CENTER)
							  GUICtrlSetColor(-1, 0x0000FF)
							  GUICtrlSetCursor(-1, 0)
							  GUICtrlSetOnEvent(-1, "RunWebSite")
							  GUICtrlCreateGroup("Remerciements", 20, 2*($tailleFenetreOptions[1]-75)/4+40, $tailleFenetreOptions[0]-40, 1*($tailleFenetreOptions[1]-75)/4-5, $BS_CENTER)
							  GUICtrlCreateEdit($remerciements, 25, 2*($tailleFenetreOptions[1]-75)/4+40+15, $tailleFenetreOptions[0]-50, 1*($tailleFenetreOptions[1]-75)/4-25, BitOR($ES_MULTILINE, $WS_VSCROLL, $ES_READONLY))
							  GUICtrlCreateGroup("Donations", 20, 3*($tailleFenetreOptions[1]-75)/4+40, $tailleFenetreOptions[0]-40, 1*($tailleFenetreOptions[1]-75)/4-5, $BS_CENTER)
							  GUICtrlCreateLabel("Si vous avez aim le " & $titre & " vous pouvez faire une donation au dveloppeur.", 25, 3*($tailleFenetreOptions[1]-75)/4+40+20, $tailleFenetreOptions[0]-60, 30, BitOR($SS_CENTER, $BS_MULTILINE))
$options_FaireUnDon[0]		= GUICtrlCreateIcon(@TempDir & "\dons.ico", -1, ($tailleFenetreOptions[0]-80)/2, 3*($tailleFenetreOptions[1]-75)/4+40+52, 16, 16)
$options_FaireUnDon[1]		= GUICtrlCreateLabel(" Faire un don", ($tailleFenetreOptions[0]-76)/2+14, 3*($tailleFenetreOptions[1]-75)/4+40+55, 65, 15)
							  GUICtrlSetFont($options_FaireUnDon[1], -1, -1, 0)
							  GUICtrlSetCursor($options_FaireUnDon[0], 0)
							  GUICtrlSetCursor($options_FaireUnDon[1], 0)
							  GUICtrlCreateGroup("", -99, -99, 1, 1)

For $i = 0 To UBound($options_Edit, 1)-2
	GUICtrlSetLimit($options_Edit[$i][0], 6)
	$options_Edit[$i][1] = GUICtrlRead($options_Edit[$i][0])
Next
$options_Edit[UBound($options_Edit, 1)-1][1] = GUICtrlRead($options_Edit[UBound($options_Edit, 1)-1][0])

Local $guiActive			= WinGetHandle("[ACTIVE]")
							  GUICtrlSetBkColor($options_Slide, 0xFFFFFF)
							  WinActivate($guiActive)

$guiRaccourcisAlternatifs	= GUICreate("RaccourcisAlternatifs", 1, 1, 1, 1, $WS_POPUP, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
							  GUISetBkColor(0xFFFFFF, $guiRaccourcisAlternatifs)

GUICtrlSetOnEvent($options_Ok, "ValiderOptions")
GUICtrlSetOnEvent($options_Defaut, "DefautOptions")
GUICtrlSetOnEvent($options_Appliquer, "AppliquerOptions")
GUICtrlSetOnEvent($options_Annuler, "AnnulerOptions")
GUICtrlSetOnEvent($options_Pipette, "InitColorPickUp")
GUICtrlSetOnEvent($options_BoutonTakeImpr, "InitTakeImpr")
GUICtrlSetOnEvent($options_Tab, "TabChange")
GUICtrlSetOnEvent($options_FaireUnDon[1], "FaireUnDon")
GUICtrlSetOnEvent($options_FaireUnDon[1], "FaireUnDon")
GUICtrlSetOnEvent($easterEgg, "InitEasterEgg")

_GUICtrl_OnHoverRegister($options_FaireUnDon[0], "HoverFaireUnDon", "HoverFaireUnDon")
_GUICtrl_OnHoverRegister($options_FaireUnDon[1], "HoverFaireUnDon", "HoverFaireUnDon")

TabChange()
AffImageTakeImpr($options_TakeImpr, $tailleFenetreImprOptions[0], $tailleFenetreImprOptions[1])
Loupe($options_PicPreview, 0, 0, $magWidth, $magHeight, Ceiling(-100-($magWidth/(2*$magZoom))), Ceiling(-100-($magHeight/(2*$magZoom))), $magWidth/$magZoom, $magHeight/$magZoom, True, $magZoom)

;~ AffOptions()

$gui	= GUICreate($titre, $tailleFenetreX-2, $tailleBase+$tailleParClip-2, 10000, 10000, $WS_POPUPWINDOW, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
GUIFillMainWindow($gui, $fleche, $listView, $options_TitreClip)
$sideFenetreMain = GetSideSize($gui)

$guiDetail								= GUICreate("", $tailleFenetreDetailDef[0], $tailleFenetreDetailDef[1], -1, -1, $WS_POPUPWINDOW, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
$details[$DETAILS_TEXTE][$DETAILS_ID]	= GUICtrlCreateEdit("", -2, -2, $tailleFenetreDetailDef[0]+2, $tailleFenetreDetailDef[1]+2, BitOR($WS_VSCROLL, $ES_MULTILINE))
$details[$DETAILS_IMAGE][$DETAILS_ID]	= GUICtrlCreatePic("", 0, 0, $tailleFenetreDetailDef[0], $tailleFenetreDetailDef[1])
$details[$DETAILS_COULEUR][$DETAILS_ID]	= GUICtrlCreateLabel("", 0, 0, $tailleBase+$tailleParClip-2, $tailleBase+$tailleParClip-2)
GUICtrlSetResizing($details[$DETAILS_TEXTE][$DETAILS_ID], $GUI_DOCKDETAILS)
GUICtrlSetResizing($details[$DETAILS_IMAGE][$DETAILS_ID], $GUI_DOCKDETAILS)
GUICtrlSetResizing($details[$DETAILS_COULEUR][$DETAILS_ID], $GUI_DOCKDETAILS)
$sideFenetreDetail = GetSideSize($guiDetail)

;~ WinSetTrans($gui, "", $transparence)
;~ WinSetTrans($guiDetail, "", $transparence)

Global $hImages					= _GUIImageList_Create(16, 16, 5, 3)
Global Const $IMAGE_FILE		= _GUIImageList_AddIcon($hImages, @SystemDir & "\shell32.dll", 0)
;~ Global Const $IMAGE_FILE		= _GUIImageList_AddIcon($hImages, @TempDir & "\file.ico")
Global Const $IMAGE_COLOR		= _GUIImageList_AddIcon($hImages, @TempDir & "\col.ico")
Global Const $IMAGE_JPG			= _GUIImageList_AddIcon($hImages, @TempDir & "\jpg.ico")
Global Const $IMAGE_TXT			= _GUIImageList_AddIcon($hImages, @TempDir & "\txt.ico")
Global Const $IMAGE_URL			= _GUIImageList_AddIcon($hImages, @TempDir & "\url.ico")
Global Const $IMAGE_CADENASF	= _GUIImageList_AddIcon($hImages, @TempDir & "\cadenasf.ico")
Global Const $IMAGE_CADENASO	= _GUIImageList_AddIcon($hImages, @TempDir & "\cadenaso.ico")
Global Const $IMAGE_EXE			= _GUIImageList_AddIcon($hImages, @SystemDir & "\shell32.dll", -3)
Global Const $IMAGE_DOSSIER		= _GUIImageList_AddIcon($hImages, @SystemDir & "\shell32.dll", -4)
_GUICtrlListView_SetImageList($listView, $hImages, 1)
_GUICtrlListView_SetImageList($exemple_ListView, $hImages, 1)

RemplirExempleMainGui($exemple_Items)

_GUIRegisterMsg($WM_CLIPBOARDUPDATE, "WM_CLIPBOARDUPDATE")
_GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
_GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")

Show()
Show()

SurveillerSouris_SetFunc("OnMouseMove")
LoadClip()
_WinAPI_AddClipboardFormatListener($gui)
OnAutoItExitRegister("exit_clipboard")


;~ For $i = 0 To $nbMaxElements-10
;~ 	Local $copie = ""
;~ 	For $j = 0 To 5
;~ 		$copie &= Random(0, 10, 1)
;~ 	Next
;~ 	ConsoleWrite($i & @CRLF)
;~ 	Local $indice = RedimClip()
;~ 	AddClip(0, $copie, $CF_TEXT, $copie, $indice, False)
;~ Next

While(True)
	If($etatTakeImpr >= 0) Then
		TakeImpr()
	ElseIf($etatColorPickUp >= 0) Then
		ColorPickUp()
	ElseIf($etatRaccourciAlt >= 0) Then
		RaccourcisAlternatifs()
	ElseIf($showMe) Then
		$showMe = False
		CacheIfShow(False)
	Else
		If($preShow And _IsPressed($KEY_SHIFT) Or _IsPressed($KEY_C) Or _IsPressed($KEY_V) Or _IsPressed($KEY_X) Or _IsPressed($KEY_WIN1) Or _IsPressed($KEY_WIN2)) Then
			StopPreShowNC()
		EndIf
		If(_IsPressed($KEY_CTRL)) Then
			If($etat[0] = False) Then
				$etat[0] = True
				If($preShow) Then
					StopPreShowNC()
					Show()
				Else
					$preShow = True
				EndIf
				AdlibRegister("StopPreShowNC", 300)
			EndIf
		ElseIf($etat[0] = True) Then
			$etat[0] = False
		EndIf
		If($show) Then
			If(_IsPressed($KEY_CTRL)) Then
				If(_IsPressed($KEY_WHEEL)) Then
					If(Not($etat[4])) Then
						$etat[4] = True
						DelSelect()
					EndIf
				Else
					$etat[4] = False
				EndIf
				If(_IsPressed($KEY_ENTER)) Then
					If(Not($etat[1])) Then
						$etat[1] = True
						Coller()
					EndIf
				Else
					$etat[1] = False
				EndIf
				If(_IsPressed($KEY_WIN1) Or _IsPressed($KEY_WIN2)) Then
					If(_IsPressed($KEY_SHIFT)) Then
						$etat[2] = False
						If(Not($etat[3])) Then
							$etat[3] = True
							LockUnlockAll()
						EndIf
					Else
						$etat[3] = False
						If(Not($etat[2])) Then
							$etat[2] = True
							LockUnlock($positionFleche)
						EndIf
					EndIf
				Else
					$etat[2] = False
					$etat[3] = False
				EndIf
				If(_IsPressed($KEY_LEFT)) Then
					ShowDetails(False)
				ElseIf(_IsPressed($KEY_RIGHT)) Then
					ShowDetails(True)
				EndIf
				If(_IsPressed($KEY_WHEEL)) Then

				EndIf
			ElseIf(_IsPressed($KEY_WHEEL)) Then
				Show()
				If($etat[1]) Then
					$etat[1] = False
				EndIf
				If($etat[2]) Then
					$etat[2] = False
				EndIf
				If($etat[3]) Then
					$etat[3] = False
				EndIf
			Else
				If($etat[1]) Then
					$etat[1] = False
				EndIf
				If($etat[2]) Then
					$etat[2] = False
				EndIf
				If($etat[3]) Then
					$etat[3] = False
				EndIf
			EndIf
			Refresh($DRAW_POSITION)
		EndIf
	EndIf
	If($etatEasterEgg >= 0) Then
		EasterEgg()
	EndIf
	Sleep(10)
WEnd

Func RemplirBoutonsAide($debut = 0, $fin = -1, $phrases = True)
	GUISwitch($guiRaccourcis)
	Local $touche[1]
	Local $size[1]
	Local $ctrls
	Local $pos
	Local $posMax = 0
	Local $y
	If($fin = -1) Then
		$fin = UBound($aideTouches, 1)-1
	EndIf
	For $i = $debut To $fin
		$ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1] = GUICtrlCreateLabel("", 0, 0, 1, 1)
		$pos = 0
		$touche = StringSplit($aideTouches[$i][0], $ASCII1, 3)
		For $j = 0 To UBound($touche, 1)-1
			$y = 10+$i*30
			If($j > 0) Then
				$ctrlIDAide[$i][$j*5-1] = GUICtrlCreateLabel("+", $pos, $y+2, 8, 13)
				$pos += 8+2
			EndIf
			$size = _StringSize($touche[$j])
			$size = $size[2]+2+5+4
			$ctrls = CreerBoutonAide($touche[$j], $pos, $y)
			For $k = 0 To UBound($ctrls, 1)-1
				$ctrlIDAide[$i][$j*5+$k] = $ctrls[$k]
			Next
			$pos += $size+3
			If($pos > $posMax) Then
				$posMax = $pos
			EndIf
		Next
		For $j = 0 To UBound($ctrlIDAide, 1)-1
			GUICtrlSetResizing($ctrlIDAide[$i][$j], $GUI_DOCKDETAILS)
		Next
		GUICtrlSetPos($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1], 0, 10+$i*30, $pos-2, 21)
		GUICtrlSetBkColor($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1], $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetOnEvent($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1], "ChangeRaccourci")
		_GUICtrl_OnHoverRegister($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1], "AfficherRaccourcisAlternatifs", "AfficherRaccourcisAlternatifs")
	Next
	If($phrases) Then
		$posMax += 5
		For $i = 0 To UBound($aidePhrases, 1)-1
			$y = 10+$i*30+4
			GUICtrlCreateLabel($aidePhrases[$i], $posMax, $y)
		Next
	EndIf
EndFunc

Func SupprimerBoutonsAide()
	For $i = 0 To UBound($ctrlIDAide, 1)-1
		SupprimerBoutonAide($i)
	Next
EndFunc

Func SupprimerBoutonAide($indice)
	For $j = 0 To UBound($ctrlIDAide, 2)-1
		If($ctrlIDAide[$indice][$j] <> "") Then
			GUICtrlDelete($ctrlIDAide[$indice][$j])
		EndIf
	Next
EndFunc

Func CreerBoutonAide($texte, $x, $y)
	Local $ctrls[4]
	Local $size = _StringSize($texte)
	$size = $size[2]+2
	$ctrls[0] = GUICtrlCreatePic(@TempDir & "\FondBoutonAide_G.bmp", $x, $y, 5, 21)
	$ctrls[1] = GUICtrlCreatePic(@TempDir & "\FondBoutonAide_M.bmp", $x+5, $y, $size, 21)
	$ctrls[2] = GUICtrlCreatePic(@TempDir & "\FondBoutonAide_D.bmp", $x+5+$size, $y, 5, 21)
	$ctrls[3] = GUICtrlCreateLabel($texte, $x+5, $y+2, $size, 15)
	GUICtrlSetBkColor($ctrls[3], $GUI_BKCOLOR_TRANSPARENT)
	Return $ctrls
EndFunc

Func ChangeRaccourci()
	Local $raccourci = -1
	For $i = 0 To UBound($ctrlIDAide, 1)-1
		If($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1] = @GUI_CtrlId) Then
			$raccourci = $i
			ExitLoop
		EndIf
	Next
;~ 	If($raccourci >= 0) Then
;~ 		ToolTip($raccourci)
;~ 	EndIf
EndFunc

Func AfficherRaccourcisAlternatifs($ctrlID, $param)
	If($param = 1) Then
		Local $cible = GetRaccourciID($ctrlID)
		If($aideTouches[$cible][1] <> "") Then
			Local $touche = StringSplit($aideTouches[$cible][1], $ASCII1, 3)
			GUISwitch($guiRaccourcisAlternatifs)
			ViderRaccourcisAlternatifs()
			Local $pos = 2
			Local $y = 0
			For $j = 0 To UBound($touche, 1)-1
				If($j > 0) Then
					$ctrlIDRaccAlt[$j*5-1] = GUICtrlCreateLabel("+", $pos, $y+2, 8, 13)
					$pos += 8+2
				EndIf
				Local $size = _StringSize($touche[$j])
				$size = $size[2]+2+5+4
				Local $ctrls = CreerBoutonAide($touche[$j], $pos, $y)
				For $k = 0 To UBound($ctrls, 1)-1
					$ctrlIDRaccAlt[$j*5+$k] = $ctrls[$k]
				Next
				$pos += $size+3
			Next
			For $i = 0 To UBound($ctrlIDRaccAlt, 1)-1
				GUICtrlSetResizing($ctrlIDRaccAlt[$i], $GUI_DOCKDETAILS)
			Next
			WinMove($guiRaccourcisAlternatifs, "", @DesktopWidth, @DesktopHeight, $pos, 21)
			CacheIfShow()
			$etatRaccourciAlt = 0
			GUISetState(@SW_SHOWNA, $guiRaccourcisAlternatifs)
		EndIf
	ElseIf($param = 2) Then
		CacheIfShow(False)
		$etatRaccourciAlt = -1
		GUISetState(@SW_HIDE, $guiRaccourcisAlternatifs)
	EndIf
EndFunc

Func IsAtLeaseOneUnProtected()
	Local $retour = False
	For $i = 0 To UBound($clip, 1)-1
		If(Not($clip[$i][$CLIP_PROTECTION])) Then
			$retour = True
			ExitLoop
		EndIf
	Next
	Return $retour
EndFunc

Func GetRaccourciID($ctrlID)
	Local $cible = -1
	For $i = 0 To UBound($ctrlIDAide, 1)-1
		If($ctrlIDAide[$i][UBound($ctrlIDAide, 2)-1] = $ctrlID) Then
			$cible = $i
			ExitLoop
		EndIf
	Next
	Return $cible
EndFunc

Func ViderRaccourcisAlternatifs()
	For $i = 0 To UBound($ctrlIDRaccAlt, 1)-1
		If($ctrlIDRaccAlt[$i] <> "") Then
			GUICtrlDelete($ctrlIDRaccAlt[$i])
		EndIf
	Next
EndFunc

Func RaccourcisAlternatifs()
	Switch $etatRaccourciAlt
		Case 0
			Local $mPos = MouseGetPos()
			If($mPos[0] <> $oldPosRaccAlt[0] Or $mPos[1] <> $oldPosRaccAlt[1]) Then
				$oldPosRaccAlt = $mPos
				WinMove($guiRaccourcisAlternatifs, "", $oldPosRaccAlt[0]+20, $oldPosRaccAlt[1]+20)
			EndIf
	EndSwitch
EndFunc

Func FaireUnDon()
	ShellExecute($siteDon)
EndFunc

Func HoverFaireUnDon($ctrlID, $param)
	If($param = 1) Then
		AdlibUnRegister("StopHoverDon")
		GUICtrlSetFont($options_FaireUnDon[1], -1, -1, 4)
	ElseIf($param = 2) Then
		AdlibRegister("StopHoverDon", 50)
	EndIf
EndFunc

Func StopHoverDon()
	AdlibUnRegister("StopHoverDon")
	GUICtrlSetFont($options_FaireUnDon[1], -1, -1, 0)
EndFunc

Func TabChange()
	GUISetState(@SW_HIDE, $guiExemple)
	GUISetState(@SW_HIDE, $guiRaccourcis)
	Switch(GUICtrlRead($options_Tab))
		Case 1
			GUISetState(@SW_SHOW, $guiExemple)
		Case 2
			GUISetState(@SW_SHOW, $guiRaccourcis)
	EndSwitch
EndFunc

Func MailTo()
	ShellExecute("mailto:" & $mail)
EndFunc

Func RunWebSite()
	ShellExecute($site)
EndFunc

Func AffOptions()
	$showOptions = Not $showOptions
	If($showOptions) Then
		TrayItemSetState($trayMenu[2], $TRAY_CHECKED)
		GUISetState(@SW_SHOW, $guiOptions)
	Else
		TrayItemSetState($trayMenu[2], $TRAY_UNCHECKED)
		GUISetState(@SW_HIDE, $guiOptions)
	EndIf
EndFunc

Func ValiderOptions()
	AppliquerOptions()
	AffOptions()
EndFunc

Func DefautOptions()
	GUICtrlSetData($options_Slide,		$options_Sensibilite_Def)
	GUICtrlSetData($options_Edit[1][0], Hex($couleur_FondSelect_Def, 6))
	GUICtrlSetData($options_Edit[2][0], Hex($couleur_TexteSelect_Def, 6))
	GUICtrlSetData($options_Edit[3][0], Hex($couleur_FondAutre_Def, 6))
	GUICtrlSetData($options_Edit[4][0], Hex($couleur_TexteAutre_Def, 6))
	GUICtrlSetData($options_Edit[5][0], $options_TitreClip_Def)
	UpdateExemple()
EndFunc

Func AppliquerOptions()
	$options_SensibiliteTemp = GUICtrlRead($options_Slide)
	If(	_IsHex($couleur_FondSelectTemp) And _
		_IsHex($couleur_TexteSelectTemp) And _
		_IsHex($couleur_FondAutreTemp) And _
		_IsHex($couleur_TexteAutreTemp)) Then
		$options_Sensibilite = $options_SensibiliteTemp
		$couleur_FondSelect = $couleur_FondSelectTemp
		$couleur_TexteSelect = $couleur_TexteSelectTemp
		$couleur_FondAutre = $couleur_FondAutreTemp
		$couleur_TexteAutre = $couleur_TexteAutreTemp
		$options_TitreClip = $options_TitreClipTemp
		For $i = 0 To $nbClip-1
;~ 			_GUICtrlListView_SetItemColor($listView, GetIndexByCtrlId($clip[$i][$CLIP_ID]), 1, $couleur_TexteAutre, $couleur_FondAutre)
			GUICtrlSetColor($clip[$i][$CLIP_ID], $couleur_TexteAutre)
			GUICtrlSetBkColor($clip[$i][$CLIP_ID], $couleur_FondAutre)
		Next
		_GUICtrlListView_SetColumn($listView, 1, _WinAPI_ExpandEnvironmentStrings($options_TitreClip))
		Colorier($positionFleche, $positionFleche, True)
		GUICtrlSetColor($fleche, $couleur_TexteSelect)
		SauverParams()
	Else
		AnnulerOptions()
	EndIf
EndFunc

Func AnnulerOptions()
	GUICtrlSetData($options_Slide, $options_Sensibilite)
	GUICtrlSetData($options_Edit[1][0], Hex($couleur_FondSelect, 6))
	GUICtrlSetData($options_Edit[2][0], Hex($couleur_TexteSelect, 6))
	GUICtrlSetData($options_Edit[3][0], Hex($couleur_FondAutre, 6))
	GUICtrlSetData($options_Edit[4][0], Hex($couleur_TexteAutre, 6))
	GUICtrlSetColor($fleche, $couleur_TexteSelect)
	AffOptions()
EndFunc

Func InitTakeImpr()
	$etatTakeImpr = 0
EndFunc

Func TakeImpr()
	Switch $etatTakeImpr
		Case 0
			$showAfterImpr = False
			If($showOptions) Then
				$showAfterImpr = True
				AffOptions()
			EndIf
			GUISetState(@SW_HIDE, $guiOptions)
			CacheIfShow()
			Do
				Sleep(10)
			Until(Not(_IsPressed("01")))
			For $i = 0 To UBound($guiImpr, 1)-1
				GUISetState(@SW_SHOW, $guiImpr[$i])
			Next
			Do
				Sleep(10)
			Until(_IsPressed("01"))
			Local $epaisseur = 1
			$mPosTakeImpr1 = MouseGetPos()
			WinMove($guiImpr[1], "", $mPosTakeImpr1[0], $mPosTakeImpr1[1], $epaisseur*2, $epaisseur*2)
			WinMove($guiImpr[2], "", $mPosTakeImpr1[0], $mPosTakeImpr1[1], $epaisseur*2, $epaisseur*2)
			WinMove($guiImpr[3], "", $mPosTakeImpr1[0], $mPosTakeImpr1[1], $epaisseur*2, $epaisseur*2)
			WinMove($guiImpr[4], "", $mPosTakeImpr1[0], $mPosTakeImpr1[1], $epaisseur*2, $epaisseur*2)
			$etatTakeImpr += 1
		Case 1
			If(_IsPressed("01")) Then
				Local $mPosTakeImpr2 = MouseGetPos()
				If(Not(@error)) Then
					$mPosTakeImpr3[0] = $mPosTakeImpr1[0]
					$mPosTakeImpr3[1] = $mPosTakeImpr1[1]
					$mPosTakeImpr3[2] = $mPosTakeImpr2[0]-$mPosTakeImpr1[0]
					$mPosTakeImpr3[3] = $mPosTakeImpr2[1]-$mPosTakeImpr1[1]
					If($mPosTakeImpr3[2] < 0) Then
						$mPosTakeImpr3[0] = $mPosTakeImpr2[0]
						$mPosTakeImpr3[2] = $mPosTakeImpr1[0]-$mPosTakeImpr2[0]
					EndIf
					If($mPosTakeImpr3[3] < 0) Then
						$mPosTakeImpr3[1] = $mPosTakeImpr2[1]
						$mPosTakeImpr3[3] = $mPosTakeImpr1[1]-$mPosTakeImpr2[1]
					EndIf
					Local $epaisseur = 1
;~ 					ToolTip($mPosTakeImpr3[0] & ", " & $mPosTakeImpr3[1] & ", " & $mPosTakeImpr3[2] & ", " & $mPosTakeImpr3[3] & @CRLF)
					WinMove($guiImpr[1], "", $mPosTakeImpr3[0]+$epaisseur, $mPosTakeImpr3[1], $mPosTakeImpr3[2]-$epaisseur, $epaisseur)
					WinMove($guiImpr[2], "", $mPosTakeImpr3[0], $mPosTakeImpr3[1], $epaisseur, $mPosTakeImpr3[3])
					WinMove($guiImpr[3], "", $mPosTakeImpr3[0], $mPosTakeImpr3[1]+$mPosTakeImpr3[3], $mPosTakeImpr3[2]+$epaisseur, $epaisseur)
					WinMove($guiImpr[4], "", $mPosTakeImpr3[0]+$mPosTakeImpr3[2], $mPosTakeImpr3[1], $epaisseur, $mPosTakeImpr3[3])
					GUICtrlSetPos($ctrlImpr, $mPosTakeImpr3[0]-$desktopSize[0], $mPosTakeImpr3[1]-$desktopSize[1], $mPosTakeImpr3[2]+1, $mPosTakeImpr3[3]+1)
				EndIf
			Else
				$etatTakeImpr += 1
			EndIf
		Case 2
			For $i = 0 To UBound($guiImpr, 1)-1
				If($i > 0) Then
					WinMove($guiImpr[$i], "", -100000, -100000, 1, 1)
				EndIf
				GUICtrlSetPos($ctrlImpr, -100000, -100000, 1, 1)
				GUISetState(@SW_HIDE, $guiImpr[$i])
			Next
			Local $hBitmap = _ScreenCapture_Capture("", $mPosTakeImpr3[0], $mPosTakeImpr3[1], $mPosTakeImpr3[2]+$mPosTakeImpr3[0], $mPosTakeImpr3[3]+$mPosTakeImpr3[1], False)
			_hBitmapToClipBoard($hBitmap)
			Local $bitmap = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
			Local $taille = DimentionshImage($bitmap)
			$taille = GetDimentionsByMinMax($taille, $tailleFenetreImprOptions)
			Local $hBitmapResize = _BitmapResize($bitmap, $taille[0], $taille[1])
			_GDIPlus_BitmapDispose($bitmap)
			_WinAPI_DeleteObject ($hBitmap)
			_WinAPI_DeleteObject(GUICtrlSendMsg($options_TakeImpr, 0x0172, 0, $hBitmapResize))
			_WinAPI_DeleteObject($hBitmapResize)
			GUISwitch($guiOptions)
			GUICtrlSetPos($options_TakeImpr, 80, 150, $taille[0], $taille[1])

;~ 			CreateMap4(5)

			$etatTakeImpr += 1
		Case 3
			If($showAfterImpr) Then
				AffOptions()
			EndIf
			CacheIfShow(False)
			$etatTakeImpr = -1
	EndSwitch
EndFunc

Func _hBitmapToClipBoard($hBitmap, $close = False)
	_ClipBoard_Open(0)
	_ClipBoard_Empty()
	_ClipBoard_SetDataEx($hBitmap, $CF_BITMAP)
	_ClipBoard_Close()
	If($close) Then
		_WinAPI_DeleteObject($hBitmap)
	EndIf
EndFunc

Func CacheIfShowNC()
	$showMe = True
	CacheIfShow()
EndFunc

Func CacheIfShow($cache = True)
	Switch $cache
		Case True
			$cacheIfShow = False
			If($show) Then
				$cacheIfShow = True
				Show()
			EndIf
		Case False
			If($cacheIfShow) Then
				Show()
			EndIf
			$cacheIfShow = False
	EndSwitch
EndFunc

Func InitColorPickUp()
	$etatColorPickUp = 0
EndFunc

Func ColorPickUp()
	Switch $etatColorPickUp
		Case 0
			CacheIfShow()
			GUICtrlSetState($options_Pipette, $GUI_HIDE)
			$colorPickUp_Col[0]		= -1
			$colorPickUp_Col[1]		= -1
			$colorPickUp_OldPos[0]	= -1
			$colorPickUp_OldPos[1]	= -1
			_SetCursorFromIconFile($OCR_NORMAL, @TempDir & "\pickup.ico", 32, 32)
			$etatColorPickUp += 1
		Case 1
			If(_IsPressed("01")) Then
				Local $mousePos = MouseGetPos()
				If(Not(@error) And $colorPickUp_OldPos[0] <> $mousePos[0] Or $colorPickUp_OldPos[1] <> $mousePos[1]) Then
					$colorPickUp_OldPos = $mousePos
					$colorPickUp_Col[0] = Hex(PixelGetColor($mousePos[0], $mousePos[1]), 6)
					Loupe($options_PicPreview, 0, 0, $magWidth, $magHeight, Ceiling($mousePos[0]-($magWidth/(2*$magZoom))), Ceiling($mousePos[1]-($magHeight/(2*$magZoom))), $magWidth/$magZoom, $magHeight/$magZoom, True, $magZoom)
					If($colorPickUp_Col[0] <> $colorPickUp_Col[1]) Then
						$colorPickUp_Col[1] = $colorPickUp_Col[0]
						GUICtrlSetData($options_Edit[0][0], $colorPickUp_Col[0])
						GUICtrlSetBkColor($options_CouleurPreview, "0x" & $colorPickUp_Col[0])
					EndIf
				EndIf
			Else
				$etatColorPickUp += 1
			EndIf
		Case 2
			_ResetCursor($OCR_NORMAL)
			GUICtrlSetState($options_Pipette, $GUI_SHOW)
			CacheIfShow(False)
			$etatColorPickUp += 1
		Case 3
			$etatColorPickUp = -1
	EndSwitch
EndFunc

Func Loupe($hPic, $dstX, $dstY, $dstW, $dstH, $srcX, $srcY, $srcW, $srcH, $cross = False, $carre = 5)
	Local $xc = Floor($dstW / 2)
	Local $yc = Floor($dstH / 2)

	Local $hDesktop = _WinAPI_GetDesktopWindow()
	Local $hDC = _WinAPI_GetDC($hDesktop)
	Local $hSrcDC = _WinAPI_CreateCompatibleDC($hDC)
	Local $hScreen = _WinAPI_CreateCompatibleBitmap($hDC, $srcW, $srcH)
	_WinAPI_SelectObject($hSrcDC, $hScreen)
	_WinAPI_BitBlt($hSrcDC, 0, 0, $srcW, $srcH, $hDC, $srcX, $srcY, $SRCCOPY)
	Local $hDstDC = _WinAPI_CreateCompatibleDC($hDC)
	Local $hBitmap = _WinAPI_CreateCompatibleBitmap($hDC, $dstW, $dstH)
	_WinAPI_SelectObject($hDstDC, $hBitmap)
	_WinAPI_SetStretchBltMode($hDstDC, $STRETCH_DELETESCANS)
	_WinAPI_StretchBlt($hDstDC, 0, 0, $dstW, $dstH, $hSrcDC, 0, 0, $srcW, $srcH, $SRCCOPY)
	_WinAPI_ReleaseDC($hDesktop, $hDC)
	If($cross) Then
		Local $hGraphics = _GDIPlus_GraphicsCreateFromHDC($hDstDC)
		Local $hPen = _GDIPlus_PenCreate(0xD0000000)
		_GDIPlus_GraphicsDrawLine($hGraphics, $dstX+($dstW/2), 0, $dstX+($dstW/2), Ceiling(($dstX+$dstH-$carre)/2)-2, $hPen)
		_GDIPlus_GraphicsDrawLine($hGraphics, $dstX+($dstW/2), ($dstX+$dstH+$carre)/2+1, $dstX+($dstW/2), $dstX+$dstH, $hPen)
		_GDIPlus_GraphicsDrawLine($hGraphics, 0, $dstY+($dstH/2), Ceiling(($dstX+$dstW-$carre)/2)-2, $dstY+($dstH/2), $hPen)
		_GDIPlus_GraphicsDrawLine($hGraphics, ($dstX+$dstW+$carre)/2+1, $dstY+($dstH/2), $dstX+$dstW, $dstY+($dstH/2), $hPen)
		_GDIPlus_GraphicsDrawRect($hGraphics, Ceiling(($dstX+$dstW-$carre)/2)-1, Ceiling(($dstX+$dstH-$carre)/2)-1, $carre+1, $carre+1, $hPen)
		_GDIPlus_GraphicsDrawRect($hGraphics, 0, 0, $dstW-1, $dstH-1, $hPen)
		_GDIPlus_PenDispose($hPen)
		_GDIPlus_GraphicsDispose($hGraphics)
	EndIf
	_WinAPI_DeleteDC($hDstDC)
	_WinAPI_DeleteDC($hSrcDC)
	_WinAPI_DeleteObject($hScreen)
	Local $hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	_WinAPI_DeleteObject($hBitmap)
	$hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
	_GDIPlus_ImageDispose($hImage)
	_WinAPI_DeleteObject(GUICtrlSendMsg($hPic, 0x0172, 0, $hBitmap))
	_WinAPI_DeleteObject($hBitmap)
EndFunc   ;==>_Capture_X3

Func OnMouseMove($dX, $dY)
	If(_IsPressed($KEY_CTRL)) Then
		If(Abs($dY) < 20) Then
			If($dX > 10 And $dX <= 200) Then
				ShowDetails(True)
			ElseIf($dX >= -200 And $dX < -10) Then
				ShowDetails(False)
			EndIf
		EndIf
	EndIf
EndFunc

Func ShowDetailsNC()
	ShowDetails(Not $showDetails)
EndFunc

Func ShowDetails($showing)
	If($showing <> $showDetails) Then
		$showDetails = $showing
		If($showDetails) Then
			TrayItemSetState($trayMenu[1], $TRAY_CHECKED)
			MAJDetail()
			Refresh($DRAW_POSITION)
			If($show) Then
				GUISetState(@SW_SHOWNA, $guiDetail)
			EndIf
		Else
			TrayItemSetState($trayMenu[1], $TRAY_UNCHECKED)
			GUISetState(@SW_HIDE, $guiDetail)
		EndIf
	EndIf
EndFunc

Func RAZTrayIcon()
	TraySetIcon(@TempDir & "\Icon_ClipKeeper.ico")
EndFunc

Func WM_CLIPBOARDUPDATE($hWnd, $iMsg, $iwParam, $ilParam)
	If($addClip) Then
		AjouterClip()
		$okNext = False
	EndIf
	AdlibRegister("GetNext", 100)
	Return 0
EndFunc

Func StopPreShowNC()
	AdlibUnRegister("StopPreShowNC")
	StopPreShow(False)
EndFunc

Func StopPreShow($flag = True)
	$preShow = False
EndFunc

Func Show()
	$show = Not $show
	If($show) Then
		TrayItemSetState($trayMenu[0], $TRAY_CHECKED)
		SurveillerSouris_Start()
		HotKeySet("^{ENTER}", "Wait")
		HotKeySet("^{DEL}"	, "DelSelect")
		HotKeySet("^+{DEL}"	, "DelAll")
		HotKeySet("^{DOWN}"	, "ScrollDown")
		HotKeySet("^{UP}"	, "ScrollUp")
		_MouseSetOnEvent($MOUSE_WHEELSCROLLDOWN_EVENT, "PreScrollDown")
		_MouseSetOnEvent($MOUSE_WHEELSCROLLUP_EVENT, "PreScrollUp")
		Refresh($DRAW_POSITION)
		GUISetState(@SW_SHOWNA, $gui)
		If($showDetails) Then
			GUISetState(@SW_SHOWNA, $guiDetail)
		EndIf
	Else
		TrayItemSetState($trayMenu[0], $TRAY_UNCHECKED)
		SurveillerSouris_Stop()
		HotKeySet("^{ENTER}")
		HotKeySet("^{DEL}")
		HotKeySet("^+{DEL}")
		HotKeySet("^{DOWN}")
		HotKeySet("^{UP}")
		_MouseSetOnEvent($MOUSE_WHEELDOWN_EVENT)
		_MouseSetOnEvent($MOUSE_WHEELSCROLLDOWN_EVENT)
		_MouseSetOnEvent($MOUSE_WHEELSCROLLUP_EVENT)
		GUISetState(@SW_HIDE, $gui)
		If($showDetails) Then
			GUISetState(@SW_HIDE, $guiDetail)
		EndIf
	EndIf
EndFunc

Func WheelDown()
	If(_IsPressed("11")) Then
		If(_IsPressed("10")) Then
			DelAll()
		Else
			DelSelect()
		EndIf
	Else
		Show()
	EndIf
EndFunc

Func GetNext()
	AdlibUnRegister("GetNext")
	$okNext = True
EndFunc

Func Wait()
	Sleep(1)
EndFunc

Func DecalerVar(ByRef $clip, $item)
	_GUICtrlListView_DeleteItem(GUICtrlGetHandle($listView), GetIndexByCtrlId($listView, $clip[$item][$CLIP_ID]))
	If(UBound($clip, 1) <= 1) Then
		For $i = 0 To UBound($clip, 2)-1
			$clip[0][$i] = 0
		Next
	Else
		For $i = $item To UBound($clip, 1)-2
			For $j = 0 To UBound($clip, 2)-1
				$clip[$i][$j] = $clip[$i+1][$j]
			Next
		Next
		ReDim $clip[UBound($clip, 1)-1][UBound($clip, 2)]
	EndIf
EndFunc

Func DelAll()
	_GUICtrlListView_BeginUpdate($listView)
	For $i = UBound($clip, 1)-1 To 0 Step -1
		DelItem($i, 0)
	Next
	_GUICtrlListView_EndUpdate($listView)
	MAJDetail()
	Refresh($DRAW_ALL, True)
	SaveClip()
EndFunc

Func DelSelect()
	AdlibUnRegister("SaveClip")
	HotKeySet("^{DEL}", "Wait")
	If($positionFleche >= 0) Then
		DelItem($positionFleche)
	EndIf
	HotKeySet("^{DEL}", "DelSelect")
	MAJDetail()
	AdlibRegister("SaveClip", 1000)
EndFunc

Func DelItem($select, $draw = $DRAW_ALL)
	If(Not($clip[$select][$CLIP_PROTECTION])) Then
		If($clip[$select][$CLIP_PREVIEW] <> 0) Then
			_WinAPI_DeleteObject($clip[$select][$CLIP_PREVIEW])
		EndIf
		DecalerVar($clip, $select)
		$nbClip -= 1
		If($nbClip = 0) Then
			$positionFleche = -1
		EndIf
		If($positionFleche >= $nbClip) Then
			$positionFleche = $nbClip-1
		EndIf
		Local $id = GetDetailIDByCtrlID($detailAffiche)
		$detailAffiche = -1
		If($id >= 0) Then
			For $i = 1 To UBound($details, 2)-1
				$details[$id][$i] = 0
			Next
		EndIf
		Refresh($draw, True)
		Colorier($select, $positionFleche, True)
	EndIf
EndFunc

Func ShowDetail($id)
	If($detailAffiche <> $id) Then
		HideDetailsItems()
		GUICtrlSetState($id, $GUI_SHOW)
		$detailAffiche = $id
	EndIf
EndFunc

Func HideDetailsItems()
	GUICtrlSetState($details[$DETAILS_TEXTE][$DETAILS_ID], $GUI_HIDE)
	GUICtrlSetState($details[$DETAILS_IMAGE][$DETAILS_ID], $GUI_HIDE)
	GUICtrlSetState($details[$DETAILS_COULEUR][$DETAILS_ID], $GUI_HIDE)
EndFunc

Func MAJDetail()
	If($positionFleche >= 0) Then
		Local $newHash = $clip[$positionFleche][$CLIP_HASH]
		Switch($clip[$positionFleche][$CLIP_CLIPTYPE])
			Case $CF_TEXT, $CF_HDROP
				If($clip[$positionFleche][$CLIP_TYPE] = 3) Then
					If(String($details[$DETAILS_COULEUR][$DETAILS_HASH]) <> String($newHash)) Then
						$details[$DETAILS_COULEUR][$DETAILS_HASH] = $newHash
						GUICtrlSetBkColor($details[$DETAILS_COULEUR][$DETAILS_ID], $clip[$positionFleche][$CLIP_DATA])
					EndIf
					$tailleFenetreDetail[0] = $tailleBase+$tailleParClip
					$tailleFenetreDetail[1] = $tailleBase+$tailleParClip
					WinMove($guiDetail, "", Default, Default, $tailleFenetreDetail[0], $tailleFenetreDetail[1])
					ShowDetail($details[$DETAILS_COULEUR][$DETAILS_ID])
				Else
					Local $texteDetail = StringReplace(StringLeft($clip[$positionFleche][$CLIP_DATA], 4096), @TAB, "    ")
					If($clip[$positionFleche][$CLIP_CLIPTYPE] = $CF_HDROP) Then
						$texteDetail = StringReplace(ClipGet(), @LF, @CRLF)
					EndIf
;~ 					ConsoleWrite($details[$DETAILS_TEXTE][$DETAILS_HASH] & " <> " & $clip[$positionFleche][$CLIP_DATA] & " : " & $newHash & @CRLF)
					If(String($details[$DETAILS_TEXTE][$DETAILS_HASH]) <> String($newHash)) Then
						$details[$DETAILS_TEXTE][$DETAILS_HASH] = $newHash
						GUICtrlSetData($details[$DETAILS_TEXTE][$DETAILS_ID], $texteDetail)
					EndIf
					Local $lignes = _GUICtrlEdit_GetLineCount($details[$DETAILS_TEXTE][$DETAILS_ID])+2
					$tailleFenetreDetail[0] = $tailleFenetreDetailDef[0]+$sideFenetreDetail[0]*2
					$tailleFenetreDetail[1] = ($lignes*13 > $tailleFenetreDetailDef[1]+$sideFenetreDetail[0]*2) ? $tailleFenetreDetailDef[1]+$sideFenetreDetail[0]*2 : $lignes*13
					WinMove($guiDetail, "", Default, Default, $tailleFenetreDetail[0], $tailleFenetreDetail[1])
					GUICtrlSetPos($details[$DETAILS_TEXTE][$DETAILS_ID], -2, -2, $tailleFenetreDetail[0]+2, $tailleFenetreDetail[1]+2)
					ShowDetail($details[$DETAILS_TEXTE][$DETAILS_ID])
				EndIf
			Case $CF_DIB
;~ 				ConsoleWrite($details[$DETAILS_IMAGE][$DETAILS_HASH] <> $newHash & @CRLF)
				If(String($details[$DETAILS_IMAGE][$DETAILS_HASH]) <> String($newHash)) Then
					$details[$DETAILS_IMAGE][$DETAILS_HASH] = $newHash
					If($clip[$positionFleche][$CLIP_PREVIEW] = 0) Then
;~ 						ConsoleWrite(StringLeft(_ClipboardToStringImage(), 200) & @LF)
;~ 						Local $aff = _BinaryString2Bitmap(_ClipboardToStringImage())
						Local $aff = _ClipBoardToImage()

						Local $taille = DimentionshImage($aff)
						$taille = GetDimentionsByMinMax($taille, $tailleFenetreDetailDef)
						$aff = _BitmapResize($aff, $taille[0], $taille[1])
						$clip[$positionFleche][$CLIP_IMGX] = $taille[0]
						$clip[$positionFleche][$CLIP_IMGY] = $taille[1]
						$clip[$positionFleche][$CLIP_PREVIEW] = $aff
					EndIf
					GUICtrlSetPos($details[$DETAILS_IMAGE][$DETAILS_ID], -1, -1,  $clip[$positionFleche][$CLIP_IMGX], $clip[$positionFleche][$CLIP_IMGY])
					_WinAPI_DeleteObject(GUICtrlSendMsg($details[$DETAILS_IMAGE][$DETAILS_ID], 0x0172, 0, $clip[$positionFleche][$CLIP_PREVIEW]))
;~ 					_WinAPI_DeleteObject($clip[$positionFleche][$CLIP_PREVIEW])
				EndIf
				$tailleFenetreDetail[0] = $clip[$positionFleche][$CLIP_IMGX]+2
				$tailleFenetreDetail[1] = $clip[$positionFleche][$CLIP_IMGY]+2
				WinMove($guiDetail, "", Default, Default, $tailleFenetreDetail[0], $tailleFenetreDetail[1])
				ShowDetail($details[$DETAILS_IMAGE][$DETAILS_ID])
			Case $CF_HDROP
				GUICtrlSetData($details[$DETAILS_TEXTE][$DETAILS_ID], StringReplace(ClipGet(), @LF, @CRLF))
				$tailleFenetreDetail[0] = $tailleFenetreDetailDef[0]+$sideFenetreDetail[0]*2
				$tailleFenetreDetail[1] = $tailleFenetreDetailDef[1]+$sideFenetreDetail[0]*2
				WinMove($guiDetail, "", Default, Default, $tailleFenetreDetail[0], $tailleFenetreDetail[1])
				ShowDetail($details[$DETAILS_TEXTE][$DETAILS_ID])
		EndSwitch
	Else
		$tailleFenetreDetail[0] = $tailleFenetreDetailDef[0]+$sideFenetreDetail[0]*2
		$tailleFenetreDetail[1] = $tailleFenetreDetailDef[1]+$sideFenetreDetail[0]*2
		WinMove($guiDetail, "", Default, Default, $tailleFenetreDetail[0], $tailleFenetreDetail[1])
		GUICtrlSetPos($details[$DETAILS_TEXTE][$DETAILS_ID], -2, -2, $tailleFenetreDetail[0]+2, $tailleFenetreDetail[1]+2)
		ShowDetail($details[$DETAILS_TEXTE][$DETAILS_ID])
	EndIf
EndFunc

Func Pause()
	$pause = Not $pause
	If($pause) Then
		_WinAPI_RemoveClipboardFormatListener($gui)
;~ 		_ClipBoard_ChangeChain($gui, $hNext)
		TrayItemSetState($trayMenu[3], $TRAY_CHECKED)
	Else
		_WinAPI_AddClipboardFormatListener($gui)
;~ 		$hNext = _ClipBoard_SetViewer($gui)
		TrayItemSetState($trayMenu[3], $TRAY_UNCHECKED)
	EndIf
EndFunc

Func GetDetailIDByCtrlID($ctrlID)
	Local $retour = -1
	For $i = 0 To UBound($details, 1)-1
		If($ctrlID = $details[$i][$DETAILS_ID]) Then
			$retour = $i
			ExitLoop
		EndIf
	Next
	Return $retour
EndFunc

Func Copier()
	AdlibUnRegister("Copier")
	Local $copie = ""
	If($positionFleche >= 0 And $positionFleche < UBound($clip, 1)) Then
		$okNext = False
;~ 		ConsoleWrite("Put : " & $clip[$positionFleche][$CLIP_DATA] & " : " & $clip[$positionFleche][$CLIP_CLIPTYPE] & @CRLF)
		_ClipBoard_SetData($clip[$positionFleche][$CLIP_DATA], $clip[$positionFleche][$CLIP_CLIPTYPE])
		If($showDetails) Then
			MAJDetail()
		EndIf
	EndIf
EndFunc

Func Coller()
	If($positionFleche >= 0 And $positionFleche < UBound($clip, 1)) Then
		Switch($clip[$positionFleche][$CLIP_TYPE])
			Case 0, 1, 3, 4
				If($clip[$positionFleche][$CLIP_CLIPTYPE] = $CF_DIB) Then
					Local $aff = _BinaryString2Bitmap(_ClipboardToStringImage())
					Local $fName = "D:\Documents and Settings\t.barthelemy\My Documents\OgrrRrrr!\assets\img\floor\" & $imageSaveNameCount & ".bmp"
					$imageSaveNameCount += 1
					_GDIPlus_ImageSaveToFile($aff, $fName)
				Else
					Send("^v")
				EndIf
			Case 2
				LancerPage($clip[$positionFleche][$CLIP_DATA])
		EndSwitch
	EndIf
EndFunc

Func LockUnlockAll()
	Local $lock = IsAtLeaseOneUnProtected() ? 1 : 0
	For $i = 0 To UBound($clip, 1)
		LockUnlock($i, $lock)
	Next
EndFunc

Func LockUnlock($item, $forceLock = -1)
	If($item >= 0 And $item < UBound($clip, 1)) Then
		Switch $forceLock
			Case -1
				$clip[$item][$CLIP_PROTECTION] = Not $clip[$item][$CLIP_PROTECTION]
			Case 0
				$clip[$item][$CLIP_PROTECTION] = False
			Case 1
				$clip[$item][$CLIP_PROTECTION] = True
		EndSwitch
		If($clip[$item][$CLIP_PROTECTION]) Then
			_GUICtrlListView_SetItemImage($listView, GetIndexByCtrlId($listView, $clip[$item][$CLIP_ID]), $IMAGE_CADENASF, 0)
		Else
			_GUICtrlListView_SetItemImage($listView, GetIndexByCtrlId($listView, $clip[$item][$CLIP_ID]), $IMAGE_CADENASO, 0)
		EndIf
	EndIf
EndFunc

Func Refresh($element = $DRAW_ALL, $force = False)
	Local $posMaxYSansClip		= @DesktopHeight-$tailleBase-$tailleParClip*($nbClip+1)-1
	Local $posMaxYAvecClip		= @DesktopHeight-$tailleBase-$tailleParClip*($nbClip+1)-1
	Local $mPos					= MouseGetPos()
	Local $positionFenetre		= $mPos
	If(BitAND($element, $DRAW_POSITION) = $DRAW_POSITION And ($force Or $mPos[0] <> $oldMPos[0] Or $mPos[1] <> $oldMPos[1] Or $showDetails <> $oldShowDetails)) Then
		$oldMPos = $mPos
		$oldShowDetails = $showDetails
		Local $supplementDetailShow	= 0
		Local $supplementDetail		= 0
		If($showDetails) Then
			$supplementDetailShow = $tailleFenetreDetail[0]
		EndIf
		If($positionFenetre[0] > (@DesktopWidth-$tailleFenetreX-20-$supplementDetailShow)) Then
			$positionFenetre[0] -= $tailleFenetreX + 40
			$supplementDetail = -1 * ($tailleFenetreX+$tailleFenetreDetail[0])
		EndIf
		If($nbClip <= 0) Then
			If($positionFenetre[1] > $posMaxYSansClip) Then
				$positionFenetre[1] = $posMaxYSansClip+20
			Else
				$positionFenetre[1] += 20
			EndIf
		Else
			If($positionFenetre[1] > $posMaxYAvecClip) Then
				If($posMaxYAvecClip >= 0) Then
					$positionFenetre[1] = $posMaxYAvecClip+20
				Else
					$positionFenetre[1] = 0
				EndIf
			Else
				$positionFenetre[1] += 20
			EndIf
		EndIf
		$positionFenetre[0] += 20
		If($nbClip <= 0) Then
			WinMove($gui, "", $positionFenetre[0], $positionFenetre[1])
			$tailleFenetreDetail[0] = $tailleFenetreDetailDef[0]+$sideFenetreDetail[0]*2
			$tailleFenetreDetail[1] = $tailleFenetreDetailDef[1]+$sideFenetreDetail[1]*2
			WinMove($guiDetail, "", $positionFenetre[0]+$tailleFenetreX+$supplementDetail, $positionFenetre[1], $tailleFenetreDetail[0], $tailleFenetreDetail[1])
			GUICtrlSetPos($details[$DETAILS_TEXTE][$DETAILS_ID], -2, -2, $tailleFenetreDetail[0]+2, $tailleFenetreDetail[1]+2)
			GUICtrlSetData($details[$DETAILS_TEXTE][$DETAILS_ID], "")
			GUICtrlSetImage($details[$DETAILS_IMAGE][$DETAILS_ID], "")
		Else
			WinMove($gui, "", $positionFenetre[0], $positionFenetre[1])
			WinMove($guiDetail, "", $positionFenetre[0]+$tailleFenetreX+$supplementDetail, $positionFenetre[1])
		EndIf
	EndIf
	If(BitAND($element, $DRAW_TAILLE) = $DRAW_TAILLE) Then
		If($nbClip <= 0) Then
			WinMove(GUICtrlGetHandle($listView), "", $espaceDebut, 0, $tailleFenetreX-$espaceDebut-2, $tailleBase+$tailleParClip-2)
			WinMove($gui, "", Default, Default, $tailleFenetreX, $tailleBase+$tailleParClip)
		Else
			WinMove(GUICtrlGetHandle($listView), "", $espaceDebut, 0, $tailleFenetreX-$espaceDebut-2, $tailleBase+$tailleParClip*$nbClip-2)
			WinMove($gui, "", Default, Default, $tailleFenetreX, $tailleBase+$tailleParClip*$nbClip)
		EndIf
	EndIf
	If(BitAND($element, $DRAW_FLECHE) = $DRAW_FLECHE) Then
		If($positionFleche < 0) Then
			GUICtrlSetPos($fleche, 5, $tailleBase-$rectif-100, 10, 15)
		Else
			GUICtrlSetPos($fleche, 5, $tailleBase+$tailleParClip*$positionFleche-$rectif, 10, 15)
		EndIf
		AdlibRegister("Copier", 150)
	EndIf
EndFunc

Func Colorier($ancienSelect, $positionFleche, $force = False)
	If($ancienSelect <> $positionFleche Or $force) Then
		If($ancienSelect >= 0 And $ancienSelect < UBound($clip, 1)) Then
;~ 			_GUICtrlListView_SetItemColor($listView, GetIndexByCtrlId($clip[$ancienSelect][$CLIP_ID]), 1, $couleur_TexteAutre, $couleur_FondAutre)
			GUICtrlSetColor($clip[$ancienSelect][$CLIP_ID], $couleur_TexteAutre)
			GUICtrlSetBkColor($clip[$ancienSelect][$CLIP_ID], $couleur_FondAutre)
		EndIf
		If($positionFleche >= 0 And $positionFleche < UBound($clip, 1)) Then
;~ 			_GUICtrlListView_SetItemColor($listView, GetIndexByCtrlId($clip[$positionFleche][$CLIP_ID]), 1, $couleur_TexteSelect, $couleur_FondSelect)
			GUICtrlSetColor($clip[$positionFleche][$CLIP_ID], $couleur_TexteSelect)
			GUICtrlSetBkColor($clip[$positionFleche][$CLIP_ID], $couleur_FondSelect)
		EndIf
	EndIf
EndFunc

Func PreScrollDown()
	If(_IsPressed($KEY_CTRL)) Then
		_GUICtrlEdit_LineScroll($details[$DETAILS_TEXTE][$DETAILS_ID], 0, 1)
	Else
		If($sensMolette < 0) Then
			$sensMolette = 1
			$nbScroll = 0
			$nbScrollMax = 1
		EndIf
		$nbScroll += 1
		If(Abs($nbScroll) >= $nbScrollMax) Then
			ScrollDown()
		EndIf
		AdlibRegister("ResetNbScrollMax", 500)
	EndIf
EndFunc

Func PreScrollUp()
	If(_IsPressed($KEY_CTRL)) Then
		_GUICtrlEdit_LineScroll($details[$DETAILS_TEXTE][$DETAILS_ID], 0, -1)
	Else
		If($sensMolette > 0) Then
			$sensMolette = -1
			$nbScroll = 0
			$nbScrollMax = 1
		EndIf
		$nbScroll -= 1
;~ 		ConsoleWrite(Abs($nbScroll) & " >= " & $nbScrollMax & @CRLF)
		If(Abs($nbScroll) >= $nbScrollMax) Then
			ScrollUp()
		EndIf
		AdlibRegister("ResetNbScrollMax", 500)
	EndIf
EndFunc

Func ScrollDown()
	Local $ancienSelect = $positionFleche
	If($nbClip > 0) Then
		Local $positionFlecheBis = $positionFleche + 1
		If($positionFlecheBis >= UBound($clip, 1)) Then
			$positionFlecheBis = 0
		EndIf
		If($positionFlecheBis <> $positionFleche) Then
			$positionFleche = $positionFlecheBis
			Refresh($DRAW_FLECHE)
			Colorier($ancienSelect, $positionFleche)
		EndIf
	EndIf
	$nbScroll = 0
	$nbScrollMax = $options_Sensibilite
EndFunc

Func ScrollUp()
	Local $ancienSelect = $positionFleche
	If($nbClip > 0) Then
		Local $positionFlecheBis = $positionFleche - 1
		If($positionFlecheBis < 0) Then
			$positionFlecheBis = UBound($clip, 1)-1
		EndIf
		If($positionFlecheBis <> $positionFleche) Then
			$positionFleche = $positionFlecheBis
			Refresh($DRAW_FLECHE)
			Colorier($ancienSelect, $positionFleche)
		EndIf
	EndIf
	$nbScroll = 0
	$nbScrollMax = $options_Sensibilite
EndFunc

Func ResetNbScrollMax()
	AdlibUnRegister("ResetNbScrollMax")
	$nbScrollMax = 1
EndFunc

Func AjouterClip()
	$addClip = False
	Local $copie = 0
	Local $hBinaryBitmap = 0
	Local $hBinaryMetafile = 0
	Local $cheminPremierFichier
	Local $nomExecutable
	Local $image = -1
	Local $indice
	If($okNext) Then
		_GUICtrlListView_BeginUpdate($listView)
		$clipGet = ClipGet()
		$copie = _ClipBoard_GetData()
		$hBinaryBitmap = _ClipBoard_GetData($CF_DIB)
		$hBinaryMetafile = _ClipBoard_GetData($CF_HDROP)
;~ 		ConsoleWrite("copie : " & $copie & @CRLF & "clipget : " & $clipGet & @CRLF & "hBinary : " & StringLeft($hBinaryBitmap, 20) & @CRLF & "meta : " & $hBinaryMetafile & @CRLF & @CRLF)
;~ 		ConsoleWrite(BinaryLen($hBinaryBitmap) & @CRLF)
		If($copie <> "0") Then
			If($copie <> "" And Unique($copie)) Then
				$indice = RedimClip()
				If(IsLink($copie)) Then
					AddClip(2, $copie, $CF_TEXT, $copie, $indice)
					$image = $IMAGE_URL
				ElseIf(_IsHex($copie)) Then
					AddClip(3, $copie, $CF_TEXT, $copie, $indice)
					$image = $IMAGE_COLOR
				Else
					AddClip(0, $copie, $CF_TEXT, $copie, $indice)
					$image = $IMAGE_TXT
				EndIf
			EndIf
		ElseIf(BinaryLen($hBinaryBitmap) >= 56 And Unique($hBinaryBitmap)) Then
;~ 			ConsoleWrite($hBinaryBitmap & @CRLF)
			$indice = RedimClip()
			$nbImages += 1
			If($options_ReduceSize > 0) Then
				Local $bitmap = _ClipboardToImage()
				Local $string = _Bitmap2BinaryString($bitmap, 100)
				_GDIPlus_BitmapDispose($bitmap)
				$bitmap = _BinaryString2Bitmap($string)
				_ImageToClipboard($bitmap)
				_GDIPlus_BitmapDispose($bitmap)
				$hBinaryBitmap = _ClipBoard_GetData($CF_DIB)
			EndIf
			AddClip(0, $hBinaryBitmap, $CF_DIB, "[Image " & $nbImages & "]", $indice)
			$image = $IMAGE_JPG
		ElseIf(BinaryLen($hBinaryMetafile) >= 8 And Unique($hBinaryMetafile)) Then
			$indice = RedimClip()
			$cheminPremierFichier = GetFirstPath($clipGet)
			$clip[$indice][$CLIP_PREVIEW] = $cheminPremierFichier
			AddClip(0, $hBinaryMetafile, $CF_HDROP, "[Fichier]" & GetNomFichier($clipGet), $indice)
			$image = _AddIcon_ExplorerLikeByFileName($hImages, $cheminPremierFichier)
		EndIf
		If($image <> -1) Then
			_GUICtrlListView_SetItemImage($listView, $indice, $image, 1)
			Refresh(BitOR($DRAW_POSITION, $DRAW_TAILLE), True)
		EndIf
		_GUICtrlListView_EndUpdate($listView)
	Else
		$okNext = True
	EndIf
	$addClip = True
EndFunc

Func AddClip($type, $donnee, $type2, $donneeAffichee, $indice, $protection = False)
	TraySetIcon(@TempDir & "\Icon_ClipKeeper_orange.ico")
	AdlibRegister("RAZTrayIcon", 200)
	AdlibRegister("SaveClip", 500)
	Local $donneeAfficheeBis
	$donneeAfficheeBis					= StringLeft($donneeAffichee, 4094)
	$clip[$indice][$CLIP_ID]			= 0
	$clip[$indice][$CLIP_TYPE]			= $type
	$clip[$indice][$CLIP_DATA]			= $donnee
	$clip[$indice][$CLIP_DATASHOW]		= $donneeAfficheeBis
	$clip[$indice][$CLIP_CLIPTYPE]		= $type2
	$clip[$indice][$CLIP_HASH]			= _Crypt_HashData($donnee, $CALG_MD5)
	$clip[$indice][$CLIP_PROTECTION]	= $protection
	$clip[$indice][$CLIP_IMGX]			= 0
	$clip[$indice][$CLIP_IMGY]			= 0
	If(StringLen($clip[$indice][$CLIP_PREVIEW]) = 0) Then
		$clip[$indice][$CLIP_PREVIEW]		= 0
	EndIf
	AddClipByIndice($indice)
	Return $indice
EndFunc

Func AddClipByIndice($indice)
	Local $imageCadenas = $IMAGE_CADENASO
	If($clip[$indice][$CLIP_PROTECTION]) Then $imageCadenas = $IMAGE_CADENASF
;~ 	$clip[$indice][$CLIP_ID]			= _GUICtrlListView_MapIndexToID($listView, _GUICtrlListView_AddItem($listView, "", $imageCadenas, 0))
	$Clip[$indice][$CLIP_ID]			= GUICtrlCreateListViewItem("", $listView)
	_GUICtrlListView_SetItemImage($listView, GetIndexByCtrlId($listView, $Clip[$indice][$CLIP_ID]), $ImageCadenas, 0)
	_GUICtrlListView_AddSubItem($listView, GetIndexByCtrlId($listView, $Clip[$indice][$CLIP_ID]), $Clip[$indice][$CLIP_DATASHOW], 1)
;~ 	_GUICtrlListView_SetItemColor($listView, GetIndexByCtrlId($clip[$indice][$CLIP_ID]), 1, $couleur_TexteAutre, $couleur_FondAutre)
	GUICtrlSetColor($clip[$indice][$CLIP_ID], $couleur_TexteAutre)
	GUICtrlSetBkColor($clip[$indice][$CLIP_ID], $couleur_FondAutre)
EndFunc

Func SaveClip()
	ConsoleWrite("Save" & @CRLF)
	AdlibUnRegister("SaveClip")
	Local $texte = ""
	Local $find = True
	For $i = 0 To $nbClip-1
		For $j = 0 To UBound($clip, 2)-1
			If($i < UBound($clip, 1) And $j < UBound($clip, 2)) Then
				$find = True
				$texte &= $clip[$i][$j] & $ASCII1
			Else
				$find = False
			EndIf
		Next
		If($find) Then
			$texte = StringTrimRight($texte, 1)
		EndIf
		$texte &= $ASCII2
	Next
	$texte = StringTrimRight($texte, 1)
	Local $file = FileOpen(@ScriptDir & "\Save.sav", 16+2)
	FileWrite($file, $texte)
	FileClose($file)
EndFunc

Func LoadClip()
	If(FileExists(@ScriptDir & "\Save.sav")) Then
		Local $file = FileOpen(@ScriptDir & "\Save.sav", 0)
		Local $contenu = FileRead($file)
		FileClose($file)
		If(StringLen($contenu) > 0) Then
			$contenu = StringSplit($contenu, $ASCII2, 3)
			$nbClip = UBound($contenu, 1)
			ReDim $clip[$nbClip][UBound($clip, 2)]
			For $i = 0 To UBound($contenu, 1)-1
				Local $temp = StringSplit($contenu[$i], $ASCII1, 3)
				For $j = 0 To UBound($temp, 1)-1
					$clip[$i][$j] = $temp[$j]
				Next
				$clip[$i][$CLIP_PROTECTION] = $clip[$i][$CLIP_PROTECTION] = "True"
				AddClipByIndice($i)
				Local $image = -1
				If($clip[$i][$CLIP_TYPE] = 0 And $clip[$i][$CLIP_CLIPTYPE] = $CF_TEXT) Then
					$image = $IMAGE_TXT
				ElseIf($clip[$i][$CLIP_TYPE] = 0 And $clip[$i][$CLIP_CLIPTYPE] = $CF_DIB) Then
					$image = $IMAGE_JPG
				ElseIf($clip[$i][$CLIP_TYPE] = 0 And $clip[$i][$CLIP_CLIPTYPE] = $CF_HDROP) Then
					$image = _AddIcon_ExplorerLikeByFileName($hImages, $clip[$i][$CLIP_PREVIEW])
				ElseIf($clip[$i][$CLIP_TYPE] = 2) Then
					$image = $IMAGE_URL
				ElseIf($clip[$i][$CLIP_TYPE] = 3) Then
					$image = $IMAGE_COLOR
				EndIf
				If($image <> -1) Then
					_GUICtrlListView_SetItemImage($listView, $i, $image, 1)
				EndIf
			Next
			Refresh($DRAW_ALL, True)
		EndIf
	EndIf
EndFunc

Func Unique($clipboard)
	Local $retour = True
	$clipboard = _Crypt_HashData($clipboard, $CALG_MD5)
	For $i = 0 To UBound($clip, 1)-1
		If(String($clipboard) = String($clip[$i][$CLIP_HASH])) Then
			$retour = False
			ExitLoop
		EndIf
	Next
	Return $retour
EndFunc

Func RedimClip()
	$nbClip += 1
	If($nbClip > $nbMaxElements-1) Then
		$nbClip -= 1
		Local $debutDecal = 0
		For $i = $debutDecal To UBound($clip, 1)-1
			If(Not($clip[$i][$CLIP_PROTECTION])) Then
				$debutDecal = $i
				ExitLoop
			EndIf
		Next
		DecalerVar($clip, $debutDecal)
		Colorier($positionFleche-1, $positionFleche)
	EndIf
	ReDim $clip[$nbClip][UBound($clip, 2)]
	Return $nbClip-1
EndFunc

Func _IsFile($fichier)
    Local $retour = False
    Local $attrib
    If(FileExists($fichier)) Then
        $attrib = FileGetAttrib($fichier)
        If(Not(StringInStr($attrib, "D"))) Then
            $retour = True
        EndIf
    Else
        SetError(1)
    EndIf
    Return $retour
EndFunc

Func GetFirstPath($chemin)
	Local $firstPath = StringSplit($chemin, @LF, 1)
	Return $firstPath[1]
EndFunc

Func GetNomFichier($chemin)
	Local $fichier = ""
	Local $split
	$chemin = StringReplace($chemin, @CRLF, @LF)
	$chemin = StringSplit($chemin, @LF, 1)
	For $i = 1 To $chemin[0]
		$split = StringSplit($chemin[$i], "\", 1)
		If($i > 1) Then
			$fichier &= ", "
		EndIf
		$fichier &= $split[$split[0]]
	Next
	Return $fichier
EndFunc

Func IsLink($lien)
	Local $retour = False
	If((StringLeft($lien, 6) = "ftp://" Or StringLeft($lien, 7) = "http://" Or StringLeft($lien, 8) = "https://" Or StringLeft($lien, 4) = "www.") And StringInStr($lien, " ") = 0) Then
		$retour = True
	EndIf
	Return $retour
EndFunc

Func _IsHex($hex)
	Local $retour = False
	$hex = StringUpper($hex)
;~ 	ConsoleWrite(StringLen($hex) & @CRLF & "Hex : " & $hex & @CRLF & StringTrimLeft($hex, 2) & " = " & Hex($hex, StringLen($hex)-2) & @CRLF)
	If(StringLen($hex) > 2 And StringLeft($hex, 2) = "0x" And StringTrimLeft($hex, 2) = Hex($hex, StringLen($hex)-2)) Then
		$retour = True
	EndIf
;~ 	ConsoleWrite($hex & " : " & $retour & @CRLF)
	Return $retour
EndFunc

Func CreerFileClip($chemin)
	$chemin = StringReplace($chemin, @CRLF, @LF)
	$chemin = StringSplit($chemin, @LF, 1)
	Local $NULL	=	StringLeft(BinaryToString(0), 1)
	Local $clip =	Chr(20) & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & $NULL & Chr(1) & $NULL
	For $j = 1 To $chemin[0]
		$clip &= $NULL & $NULL
		For $i = 1 To StringLen($chemin[$j])
			$clip &=  StringMid($chemin[$j], $i, 1) & $NULL
		Next
	Next
	$clip &= $NULL & $NULL & $NULL & $NULL
	Return $clip
EndFunc

Func LancerPage($page)
	ShellExecute($page)
EndFunc

Func GetDimentionsByMinMax($tailleBase, $tailleMax, $nonZero = True)
	Local $taille[2]
	Local $div[2] = [$tailleBase[0]/$tailleMax[0], $tailleBase[1]/$tailleMax[1]]
	Local $coef = $tailleMax[0]/$tailleBase[0]
	If($div[0] < 1 And $div[1] < 1) Then
		$coef = 1
	ElseIf($div[0] < $div[1]) Then
		$coef = $tailleMax[1]/$tailleBase[1]
	EndIf
;~ 	ConsoleWrite($tailleBase[0] & ", " & $tailleBase[1] & ", " & $coef & @CRLF)
	$taille[0] = Floor($tailleBase[0]*$coef)
	$taille[1] = Floor($tailleBase[1]*$coef)
	If($nonZero And $taille[0] = 0) Then
		$taille[0] = 1
	EndIf
	If($nonZero And $taille[1] = 0) Then
		$taille[1] = 1
	EndIf
;~ 	ConsoleWrite($taille[0] & ", " & $taille[1] & @CRLF)
	Return $taille
EndFunc

Func WM_COMMAND($hWnd, $msg, $wParam, $lParam)
	Local $hiWord = _WinAPI_HiWord($wParam)
	Local $loWord = _WinAPI_LoWord($wParam)
	Local $read
	Local $sel
	If($hiWord = 768) Then
		For $i = 0 To UBound($options_Edit, 1)-1
			If($options_Edit[$i][0] = $loWord) Then
				$read = GUICtrlRead($options_Edit[$i][0])
				Local $col = "0x" & StringFormat("%06s", $read)
					Local $sel = _GUICtrlEdit_GetSel($options_Edit[$i][0])
				If($i = 0) Then
					$read = StringUpper($read)
					If(_IsHex($col)) Then
						$options_Edit[$i][1] = $read
						GUICtrlSetBkColor($options_CouleurPreview, $col)
					EndIf
					GUICtrlSetData($options_Edit[$i][0], $options_Edit[$i][1])
				ElseIf($i = 5) Then
					$options_Edit[$i][1] = $read
					UpdateExemple()
				Else
					$read = StringUpper($read)
					If(_IsHex($col)) Then
						$options_Edit[$i][1] = $read
						UpdateExemple()
					EndIf
					GUICtrlSetData($options_Edit[$i][0], $options_Edit[$i][1])
				EndIf
				_GUICtrlEdit_SetSel($options_Edit[$i][0], $sel[0], $sel[1])
			EndIf
		Next
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_NOTIFY($hWnd, $msg, $wParam, $lParam)
	Local $struct = DllStructCreate($tagNMHDR, $lParam)
	Local $ctrlID = DllStructGetData($struct, "idFrom")

	If($ctrlID = $options_Slide) Then
		GUICtrlSetData($options_molette, GUICtrlRead($options_Slide))
	EndIf
    Return -1
EndFunc

Func GetSideSize($hWnd, $dim = -1)
	Local $clientSize = WinGetClientSize($hWnd)
	Local $winSize = WinGetPos($hWnd)
	Local $size[2]
	$size[0] = Round(($winSize[2]-$clientSize[0])/2)
	$size[1] = $winSize[3]-$clientSize[1]-$size[0]
	Switch $dim
		Case 0
			$size = Round(($winSize[2]-$clientSize[0])/2)
		Case 1
			$size = $winSize[3]-$clientSize[1]-$size[0]
	EndSwitch
	Return $size
EndFunc

Func AffImageTakeImpr($hPic, $w, $h)
	Local $guiGDI = GUICreate("", $w, $h)

	Local $hDC = _WinAPI_GetDC($guiGDI)
	Local $hDstDC = _WinAPI_CreateCompatibleDC($hDC)
	Local $hBitmap = _WinAPI_CreateCompatibleBitmap($hDC, $w, $h)
	_WinAPI_SelectObject($hDstDC, $hBitmap)
	_WinAPI_ReleaseDC($guiGDI, $hDC)
	Local $hGraphics = _GDIPlus_GraphicsCreateFromHDC($hDstDC)
	Local $hPenNoir = _GDIPlus_PenCreate(0xFF000000)
	Local $hBrosseBlanche = _GDIPlus_BrushCreateSolid(0xFFFFFFFF)
	Local $imagePicture = _GDIPlus_ImageLoadFromFile(@TempDir & "\Picture.ico")
	_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $w, $h, $hBrosseBlanche)
	_GDIPlus_GraphicsDrawLine($hGraphics, 0, 0, $w, 0, $hPenNoir)
	_GDIPlus_GraphicsDrawLine($hGraphics, 0, 0, 0, $h, $hPenNoir)
	_GDIPlus_GraphicsDrawLine($hGraphics, $w-1, 0, $w-1, $h, $hPenNoir)
	_GDIPlus_GraphicsDrawLine($hGraphics, 0, $h-1, $w, $h-1, $hPenNoir)
	_GDIPlus_GraphicsDrawString($hGraphics, "Pour prendre une impression cran", 5, ($h/2)-30)
	_GDIPlus_GraphicsDrawString($hGraphics, "Cliquez sur", 60, ($h/2))
	_GDIPlus_GraphicsDrawImage($hGraphics, $imagePicture, 130, ($h/2)-10)
	_GDIPlus_GraphicsDrawString($hGraphics, "Puis faites un clic gliss.", 40, ($h/2)+20)
	_GDIPlus_PenDispose($hBrosseBlanche)
	_GDIPlus_PenDispose($hPenNoir)
	_GDIPlus_GraphicsDispose($hGraphics)
	_WinAPI_DeleteDC($hDstDC)
	Local $hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	_WinAPI_DeleteObject($hBitmap)
	$hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
	_GDIPlus_ImageDispose($imagePicture)
	_GDIPlus_ImageDispose($hImage)
	_WinAPI_DeleteObject(GUICtrlSendMsg($hPic, 0x0172, 0, $hBitmap))
	_WinAPI_DeleteObject($hBitmap)
	GUIDelete($guiGDI)
EndFunc

Func GUIFillMainWindow(ByRef $gui1, ByRef $fleche1, ByRef $listView1, $titre)
				  GUICtrlCreateLabel("", 0, 0, $tailleFenetreX, @DesktopHeight)
				  GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	$fleche1	= GUICtrlCreateLabel("->", 5, $tailleBase-$rectif-100, 10, 15)
	$listView1	= GUICtrlCreateListView("", $espaceDebut, 0, $tailleFenetreX-$espaceDebut-2, $tailleBase+$tailleParClip-2, -1, $WS_EX_CLIENTEDGE)
	_GUICtrlListView_SetExtendedListViewStyle($listView1, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES, $LVS_EX_DOUBLEBUFFER))
	GUICtrlSetResizing($fleche1, $GUI_DOCKDETAILS)
	_GUICtrlListView_AddColumn($listView1, "", 22)
	_GUICtrlListView_AddColumn($listView1, _WinAPI_ExpandEnvironmentStrings($titre), $tailleFenetreX-$espaceDebut-30)
EndFunc

Func RemplirExempleMainGui(ByRef $items)
	ReDim $items[4]
	Local $exe = _WinAPI_FindExecutable(@ScriptFullPath)
	Local $image = _GUIImageList_AddIcon($hImages, $exe, 0)
	$items[0] = GUICtrlCreateListViewItem("", $exemple_ListView)
	$items[1] = GUICtrlCreateListViewItem("", $exemple_ListView)
	$items[2] = GUICtrlCreateListViewItem("", $exemple_ListView)
	$items[3] = GUICtrlCreateListViewItem("", $exemple_ListView)
	_GUICtrlListView_AddSubItem($exemple_ListView, 0, "[Fichier] ClipKeeper.exe", 1, $image)
	_GUICtrlListView_AddSubItem($exemple_ListView, 1, "Programm par " & $pseudo, 1, $IMAGE_TXT)
	_GUICtrlListView_AddSubItem($exemple_ListView, 2, "http://autoitscript.fr/forum", 1, $IMAGE_URL)
	_GUICtrlListView_AddSubItem($exemple_ListView, 3, "[Image 1]", 1, $IMAGE_JPG)
	_GUICtrlListView_SetItemImage($exemple_ListView, 0, $IMAGE_CADENASO)
	_GUICtrlListView_SetItemImage($exemple_ListView, 1, $IMAGE_CADENASO)
	_GUICtrlListView_SetItemImage($exemple_ListView, 2, $IMAGE_CADENASO)
	_GUICtrlListView_SetItemImage($exemple_ListView, 3, $IMAGE_CADENASO)
	GUICtrlSetBkColor($exemple_Items[0], $couleur_FondAutre)
	GUICtrlSetColor($exemple_Items[0], $couleur_TexteAutre)
	GUICtrlSetBkColor($exemple_Items[1], $couleur_FondSelect)
	GUICtrlSetColor($exemple_Items[1], $couleur_TexteSelect)
	GUICtrlSetBkColor($exemple_Items[2], $couleur_FondAutre)
	GUICtrlSetColor($exemple_Items[2], $couleur_TexteAutre)
	GUICtrlSetBkColor($exemple_Items[3], $couleur_FondAutre)
	GUICtrlSetColor($exemple_Items[3], $couleur_TexteAutre)
	Local $posExemple = WinGetPos($guiExemple)
	Local $posOptions = WinGetPos($guiOptions)
	Local $sideSize = GetSideSize($guiOptions)
	Local $pos[2] = [$posExemple[0]-$posOptions[0]-$sideSize[0], $posExemple[1]-$posOptions[1]-$sideSize[1]]
	WinMove($guiExemple, "", $pos[0], $pos[1], $tailleFenetreX, $tailleBase+$tailleParClip*4)
EndFunc

Func UpdateExemple()
	Local $titreClip = $options_Edit[5][1]
	Local $colFondSel = "0x" & $options_Edit[1][1]
	Local $colTexteSel = "0x" & $options_Edit[2][1]
	Local $colFondAutre = "0x" & $options_Edit[3][1]
	Local $colTexteAutre = "0x" & $options_Edit[4][1]
;~ 	ConsoleWrite($colFondSel & ", " & $colTexteSel & ", " & $colFondAutre & ", " & $colTexteAutre & @LF)
	If($colFondSel <> $couleur_FondSelectTemp Or $colTexteSel <> $couleur_TexteSelectTemp) Then
		$couleur_FondSelectTemp = $colFondSel
		$couleur_TexteSelectTemp = $colTexteSel
		GUICtrlSetBkColor($exemple_Items[1], $couleur_FondSelectTemp)
		GUICtrlSetColor($exemple_Items[1], $couleur_TexteSelectTemp)
		GUICtrlSetColor($exemple_Fleche, $couleur_TexteSelectTemp)
	EndIf
	If($colFondAutre <> $couleur_FondAutreTemp Or $colTexteAutre <> $couleur_TexteAutreTemp) Then
		$couleur_FondAutreTemp = $colFondAutre
		$couleur_TexteAutreTemp = $colTexteAutre
		GUICtrlSetBkColor($exemple_Items[0], $couleur_FondAutreTemp)
		GUICtrlSetColor($exemple_Items[0], $couleur_TexteAutreTemp)
		GUICtrlSetBkColor($exemple_Items[2], $couleur_FondAutreTemp)
		GUICtrlSetColor($exemple_Items[2], $couleur_TexteAutreTemp)
		GUICtrlSetBkColor($exemple_Items[3], $couleur_FondAutreTemp)
		GUICtrlSetColor($exemple_Items[3], $couleur_TexteAutreTemp)
	EndIf
	If(StringCompare($titreClip, $options_TitreClipTemp, 1) <> 0) Then
		$options_TitreClipTemp = $titreClip
		_GUICtrlListView_SetColumn($exemple_ListView, 1, _WinAPI_ExpandEnvironmentStrings($options_TitreClipTemp))
	EndIf
EndFunc

;~ Func GetIndexByCtrlId($id)
;~ 	Return _GUICtrlListView_MapIDToIndex($listView, $id)
;~ EndFunc

Func GetIndexByCtrlId($listView, $Id)
	Local $Index = -1
	For $i = 0 To UBound($Clip, 1)-1
		If($Clip[$i][$CLIP_ID] = $Id) Then
			$Index = $i
			ExitLoop
		EndIf
	Next
	Return $Index
EndFunc

Func InitEasterEgg()
	GUICtrlSetOnEvent($easterEgg, "")
	$etatEasterEgg += 1
	$indiceEasterEgg = 0
	$easterEggStep = 1
EndFunc

Func StopEasterEgg()
	$etatEasterEgg = -1
	GUIDelete($guiEasterEgg)
	GUICtrlSetState($easterEgg, $GUI_SHOW)
EndFunc

Func EasterEgg()
	Local $vitesse = 5
	Switch $etatEasterEgg
		Case 0
			$etatEasterEgg += 1
		Case 1
			$posEasterEgg[0] = $posCkBig[0]
			$posEasterEgg[1] = $posCkBig[1]
			$timerEasterEgg = TimerInit()
			$etatEasterEgg += 1
		Case 2, 3
			If(TimerDiff($timerEasterEgg) > 50) Then
				$indiceEasterEgg += 1
				If($indiceEasterEgg < 15) then
					Local $pos[2][2] = [[$posCkBig[0]-3, $posCkBig[1]], [$posCkBig[0]+3, $posCkBig[1]]]
					$posEasterEgg[0] = $pos[Mod($indiceEasterEgg, 2)][0]
					$posEasterEgg[1] = $pos[Mod($indiceEasterEgg, 2)][1]
					GUICtrlSetPos($easterEgg, $posEasterEgg[0], $posEasterEgg[1])
				ElseIf($indiceEasterEgg = 15) Then
					GUICtrlSetOnEvent($easterEgg, "InitEasterEgg")
					$posEasterEgg[0] = $posCkBig[0]
					$posEasterEgg[1] = $posCkBig[1]
					GUICtrlSetPos($easterEgg, $posEasterEgg[0], $posEasterEgg[1])
				Else
					If($etatEasterEgg = 3) Then
						$etatEasterEgg += 1
					EndIf
				EndIf
				$timerEasterEgg = TimerInit()
			EndIf
		Case 4
			$posEasterEgg = WinGetPos($guiOptions)
			$posEasterEgg[0] += GetSideSize($guiOptions, 0)+$posCkBig[0]
			$posEasterEgg[1] += GetSideSize($guiOptions, 1)+$posCkBig[1]
			$posEasterEggAnim[0] = $posEasterEgg[0]-($easterEggStep*$vitesse)
			$posEasterEggAnim[1] = $posEasterEgg[1]
;~ 			ConsoleWrite($posEasterEgg[0] & ", " & $posEasterEgg[1] & @CRLF)
			$guiEasterEgg = GUICreate("EasterEgg", 64, 64, $posEasterEgg[0], $posEasterEgg[1], $WS_POPUP, BitOR($WS_EX_LAYERED, $WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
			GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "StopEasterEgg")
			SetBitmap($guiEasterEgg, @TempDir & "\ckbig.png")
			GUISetState(@SW_SHOW, $guiEasterEgg)
			GUICtrlSetState($easterEgg, $GUI_HIDE)
			$timerEasterEgg = TimerInit()
			$etatEasterEgg += 1
			If($posEasterEgg[0] > $desktopArea[4]/2) Then
				$easterEggStep = -1
			EndIf
		Case 5
			If(TimerDiff($timerEasterEgg) > 20) Then
				Local $t
				Local $decalage = 200
				Local $amplitude = Round($decalage/2)
				$posEasterEggAnim[0] += ($easterEggStep*$vitesse)
				$t = ($posEasterEggAnim[0]-$posEasterEgg[0])*$easterEggStep
				$posEasterEggAnim[1] = (($t-$decalage)*($t-$decalage))/$amplitude+$posEasterEgg[1]-($decalage*$decalage/$amplitude)
				WinMove($guiEasterEgg, "", $posEasterEggAnim[0], $posEasterEggAnim[1])
				If($posEasterEggAnim[0]+64 >= $desktopArea[4] Or $posEasterEggAnim[1]+64 >= $desktopArea[5] Or $posEasterEggAnim[0] <= 0) Then
					If($posEasterEggAnim[0]+64 >= $desktopArea[4]) Then
						$posEasterEggAnim[0] = $desktopArea[4]-64
					ElseIf($posEasterEggAnim[0] <= 0) Then
						$posEasterEggAnim[0] = 0
					Else
						$posEasterEggAnim[1] = $desktopArea[5]-64
						$etatEasterEgg += 1
					EndIf
					WinMove($guiEasterEgg, "", $posEasterEggAnim[0], $posEasterEggAnim[1])
					$etatEasterEgg += 1
				EndIf
				$timerEasterEgg = TimerInit()
			EndIf
		Case 6
			$posEasterEggAnim[1] += $vitesse
			If($posEasterEggAnim[1]+64 >= $desktopArea[5]) Then
				$posEasterEggAnim[1] = $desktopArea[5]-64
				$etatEasterEgg += 1
			EndIf
			WinMove($guiEasterEgg, "", $posEasterEggAnim[0], $posEasterEggAnim[1])
		Case 7
			$posEasterEggAnim[0] += Round($easterEggStep*($vitesse/2))
			If($posEasterEggAnim[0]+64 >= $desktopArea[4]) Then
				$easterEggStep *= -1
				$posEasterEggAnim[0] = $desktopArea[4]-64
			ElseIf($posEasterEggAnim[0] <= 0) Then
				$easterEggStep *= -1
				$posEasterEggAnim[0] = 0
			EndIf
			WinMove($guiEasterEgg, "", $posEasterEggAnim[0], $posEasterEggAnim[1])
		Case 8
			StopEasterEgg()
	EndSwitch
EndFunc

Func ChargerParams()
	If(FileExists($fichierConfig)) Then
		$options_TitreClip		= IniRead($fichierConfig, "TitreClipKeeper", "Titre", "-1")
		$options_Sensibilite	= IniRead($fichierConfig, "VitesseMolette", "Vitesse", "-1")
		$options_ReduceSize		= IniRead($fichierConfig, "PoidImpr", "ReduirPoidImpr", "0")
		$couleur_FondSelect		= IniRead($fichierConfig, "Couleurs", "SelFond", "-1")
		$couleur_TexteSelect	= IniRead($fichierConfig, "Couleurs", "SelTexte", "-1")
		$couleur_FondAutre		= IniRead($fichierConfig, "Couleurs", "AutreFond", "-1")
		$couleur_TexteAutre		= IniRead($fichierConfig, "Couleurs", "AutreTexte", "-1")
	EndIf
	If($options_TitreClip = -1) Then
		$options_TitreClip		= $options_TitreClip_Def
	EndIf
	If($options_Sensibilite < 1 Or $options_Sensibilite > 10) Then
		$options_Sensibilite	= $options_Sensibilite_Def
	EndIf
	If($options_ReduceSize < 0) Then
		$options_ReduceSize		= $options_ReduceSize_Def
	EndIf
	If($couleur_FondSelect = -1 Or Not(_IsHex($couleur_FondSelect))) Then
		$couleur_FondSelect		= "0x" & Hex($couleur_FondSelect_Def, 6)
	EndIf
	If($couleur_TexteSelect = -1 Or Not(_IsHex($couleur_TexteSelect))) Then
		$couleur_TexteSelect	= "0x" & Hex($couleur_TexteSelect_Def, 6)
	EndIf
	If($couleur_FondAutre = -1 Or Not(_IsHex($couleur_FondAutre))) Then
		$couleur_FondAutre		= "0x" & Hex($couleur_FondAutre_Def, 6)
	EndIf
	If($couleur_TexteAutre = -1 Or Not(_IsHex($couleur_TexteAutre))) Then
		$couleur_TexteAutre		= "0x" & Hex($couleur_TexteAutre_Def, 6)
	EndIf
	$options_TitreClipTemp	= $options_TitreClip
	$options_SensibiliteTemp= $options_Sensibilite
	$couleur_FondSelectTemp	= $couleur_FondSelect
	$couleur_TexteSelectTemp= $couleur_TexteSelect
	$couleur_FondAutreTemp	= $couleur_FondAutre
	$couleur_TexteAutreTemp	= $couleur_TexteAutre
	SauverParams()
EndFunc

Func SauverParams()
	IniWrite($fichierConfig, "TitreClipKeeper", "Titre", $options_TitreClip)
	IniWrite($fichierConfig, "VitesseMolette", "Vitesse", $options_Sensibilite)
	IniWrite($fichierConfig, "Couleurs", "SelFond", "0x" & Hex($couleur_FondSelect, 6))
	IniWrite($fichierConfig, "Couleurs", "SelTexte", "0x" & Hex($couleur_TexteSelect, 6))
	IniWrite($fichierConfig, "Couleurs", "AutreFond", "0x" & Hex($couleur_FondAutre, 6))
	IniWrite($fichierConfig, "Couleurs", "AutreTexte", "0x" & Hex($couleur_TexteAutre, 6))
	IniWrite($fichierConfig, "PoidImpr", "ReduirPoidImpr", $options_ReduceSize)
EndFunc

Func FileInstalls()
	FileInstall("images\cadenasf.ico", @TempDir & "\cadenasf.ico", 1)
	FileInstall("images\cadenaso.ico", @TempDir & "\cadenaso.ico", 1)
	FileInstall("images\ckbig.ico", @TempDir & "\ckbig.ico", 1)
	FileInstall("images\ckbig.png", @TempDir & "\ckbig.png", 1)
	FileInstall("images\col.ico", @TempDir & "\col.ico", 1)
	FileInstall("images\couleur.ico", @TempDir & "\couleur.ico", 1)
	FileInstall("images\dons.ico", @TempDir & "\dons.ico", 1)
	FileInstall("images\file.ico", @TempDir & "\file.ico", 1)
	FileInstall("images\FondBoutonAide_D.bmp", @TempDir & "\FondBoutonAide_D.bmp", 1)
	FileInstall("images\FondBoutonAide_G.bmp", @TempDir & "\FondBoutonAide_G.bmp", 1)
	FileInstall("images\FondBoutonAide_M.bmp", @TempDir & "\FondBoutonAide_M.bmp", 1)
	FileInstall("images\Icon_ClipKeeper.ico", @TempDir & "\Icon_ClipKeeper.ico", 1)
	FileInstall("images\Icon_ClipKeeper_orange.ico", @TempDir & "\Icon_ClipKeeper_orange.ico", 1)
	FileInstall("images\jpg.ico", @TempDir & "\jpg.ico", 1)
	FileInstall("images\molette.ico", @TempDir & "\molette.ico", 1)
	FileInstall("images\pickup.ico", @TempDir & "\pickup.ico", 1)
	FileInstall("images\picture.ico", @TempDir & "\picture.ico", 1)
	FileInstall("images\txt.ico", @TempDir & "\txt.ico", 1)
	FileInstall("images\url.ico", @TempDir & "\url.ico", 1)
EndFunc

Func DelFiles()
	FileDelete(@TempDir & "\cadenasf.ico")
	FileDelete(@TempDir & "\cadenaso.ico")
	FileDelete(@TempDir & "\ckbig.ico")
	FileDelete(@TempDir & "\ckbig.png")
	FileDelete(@TempDir & "\col.ico")
	FileDelete(@TempDir & "\couleur.ico")
	FileDelete(@TempDir & "\dons.ico")
	FileDelete(@TempDir & "\file.ico")
	FileDelete(@TempDir & "\FondBoutonAide_D.bmp")
	FileDelete(@TempDir & "\FondBoutonAide_G.bmp")
	FileDelete(@TempDir & "\FondBoutonAide_M.bmp")
	FileDelete(@TempDir & "\Icon_ClipKeeper.ico")
	FileDelete(@TempDir & "\Icon_ClipKeeper_orange.ico")
	FileDelete(@TempDir & "\jpg.ico")
	FileDelete(@TempDir & "\molette.ico")
	FileDelete(@TempDir & "\pickup.ico")
	FileDelete(@TempDir & "\picture.ico")
	FileDelete(@TempDir & "\txt.ico")
	FileDelete(@TempDir & "\url.ico")
EndFunc

Func GetRemerciements()
	Local $remerciements = ""
	$remerciements &=	"Merci  la communaut Franaise et Amricaine pour certaines fonctions." & @CRLF & @CRLF & _
						"Merci surtout  Tlem et aux modrateurs du forum AutoIt franais pour tenir un forum de qualit permettant la motivation  l'apprentissage."
	Return $remerciements
EndFunc

Func GetHeaderHeight($listView)
	Local $header = _GUICtrlListView_GetHeader($listView)
	Global $rc = _WinAPI_GetWindowRect($header)
	Return DllStructGetData($rc, "Bottom") - DllStructGetData($rc, "Top") & @CRLF
EndFunc

Func GetItemHeight($listView)
	Local $id = _GUICtrlListView_AddItem($listView, ".")
	Local $temp = _GUICtrlListView_GetItemRect($listView, $id)
	_GUICtrlListView_DeleteItem($listView, $id)
	Return $temp[3] - $temp[1]
EndFunc

Func InitVariables()
	Local $guiTest = GUICreate("", 100, 100)
	Local $listView = GUICtrlCreateListView(".", 0, 0, 100, 100)
	$tailleBase = GetHeaderHeight($listView)+6
	$tailleParClip = GetItemHeight($listView)
	$side = GetSideSize($guiTest)
	$nbMaxElements = Floor((@DesktopHeight-$tailleBase)/$tailleParClip)
	GUIDelete($guiTest)
EndFunc

Func exit_gdiplus()
	_GDIPlus_Shutdown()
EndFunc

Func exit_clipboard()
	_WinAPI_RemoveClipboardFormatListener($gui)
EndFunc

Func exit_FreeWindowsRessources()
	GUIDelete($gui)
	GUIDelete($guiDetail)
	GUIDelete($guiOptions)
	For $i = 0 To UBound($guiImpr, 1)-1
		GUIDelete($guiImpr[$i])
	Next
EndFunc

Func quit()
	DelFiles()
	SaveClip()
	Exit
EndFunc
