#include <Clipboard.au3>
#include <GDIPlus.au3>
#include <Memory.au3>
#include <WinAPI.au3>
#include <GDIPlus.au3>
#include <WinAPI.au3>
#include "Bitmap_String.au3"
Opt("MustDeclareVars", 1)

_GDIPlus_Startup()
OnAutoItExitRegister("_ExitBitmap")

Func _hBitmapResize($hImage, $iW, $iH)
	Return _BitmapResize(_GDIPlus_BitmapCreateFromHBITMAP($hImage), $iW, $iH)
EndFunc

Func _BitmapResize($Image, $iW, $iH)
;~ 	ConsoleWrite($iW & ", " & $iH & @CRLF)
	Local $hBitmap = _WinAPI_CreateBitmap($iW, $iH, 1, 32)
	Local $hImage1 = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	Local $hgraphic = _GDIPlus_ImageGetGraphicsContext($hImage1)
	_GDIPlus_GraphicsDrawImageRect($hgraphic, $Image, 0, 0, $iW, $iH)
	Local $hBitmap2 = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage1)
	_WinAPI_DeleteObject($hBitmap)
	_GDIPlus_ImageDispose($hImage1)
	_GDIPlus_GraphicsDispose($hgraphic)
    Return $hBitmap2
EndFunc

Func _ClipboardToImage($quality = 100)
	_ClipBoard_Open(0)
	Local $hBitmap = _ClipBoard_GetDataEx($CF_BITMAP)
	Local $hbmpp = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	_ClipBoard_Close()
	_WinAPI_DeleteObject($hBitmap)
	If($quality < 100) Then
		Local $string = _Bitmap2BinaryString($hbmpp, $quality)
		_GDIPlus_BitmapDispose($hbmpp)
		$hbmpp = _BinaryString2Bitmap($string)
	EndIf
	Return $hbmpp
EndFunc

;~ #include <ScreenCapture.au3>
;~ Local $hBitmap = _ScreenCapture_Capture("")
;~ Local $bitmap = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
;~ Local $bitmap2 = _BinaryString2Bitmap(_Bitmap2BinaryString($bitmap, 90))
;~ _ImageToClipboard($bitmap2)


Func _ImageToClipboard($bitmap, $isBitmap = True)
	Local $dispose = False
	Local $hBitmap = $bitmap
	If($isBitmap) Then
		$dispose = True
		$hBitmap = _GDIPlus_ImageCreateGDICompatibleHBITMAP($bitmap)
	EndIf
	_ClipBoard_Open(0)
	_ClipBoard_Empty()
	_ClipBoard_SetDataEx($hBitmap, $CF_BITMAP)
	_ClipBoard_Close()
	If($dispose) Then
		_WinAPI_DeleteObject($hBitmap)
	EndIf
EndFunc

;=============================================================================== ;
; Function Name:   _GDIPlus_ImageCreateGDICompatibleHBITMAP
; Description::    Converts a GDIPlus-Image to GDI-combatible HBITMAP
; Parameter(s):    $hImg -> GDIplus Image object ; Requirement(s):  GDIPlus.au3
; Return Value(s): HBITMAP, compatible with ClipBoard
; Author(s):       Prog@ndy ;
;===============================================================================
Func _GDIPlus_ImageCreateGDICompatibleHBITMAP($hImg)
	Local $hBitmap2 = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImg)
	Local $hBitmap = _WinAPI_CopyImage($hBitmap2,0,0,0,$LR_COPYDELETEORG+$LR_COPYRETURNORG)
	_WinAPI_DeleteObject($hBitmap2)
	Return $hBitmap
EndFunc

Func _ClipboardToStringImage()
	_ClipBoard_Open(0)
	; C'est ici le plus important !!
	; $CF_DIB - structure BITMAPINFO
	Local $hBinaryBitmap = _ClipBoard_GetDataEx($CF_DIB)
	; On vrifie si y a pas d'erreur
	If @error Then SetError(1,0,0)
	; On bloque en mmoire l'information du presse papier
	Local $pImageBytes = _MemGlobalLock($hBinaryBitmap)
	; on rcupere la taille mit en mmoire par le presse papier
	Local $nImageSize = _MemGlobalSize($hBinaryBitmap)

	; Cration de l'entte du fichier (le header) *.bmp
	Local $str = Binary("BM") & StringTrimLeft(Binary($nImageSize + 14), 2) & "0000000036000000"
	; Cration d'une Structure tampon pour stocker la taille vers le pointer $hBinaryBitmap
	Local $sImageBuffer = DllStructCreate('byte[' & $nImageSize & ']',$hBinaryBitmap)
	Local $pImageBuffer = DllStructGetPtr($sImageBuffer)

	;on envoie la capture (ce qui a t bloqu) vers la structure avec sa taille
	_MemMoveMemory($pImageBytes, $pImageBuffer, $nImageSize)
	; on dbloque de la mmoire l'information du presse papier
	_MemGlobalUnlock($hBinaryBitmap)
	; Fermeture du Presse papier
	_ClipBoard_Close()

	;IMAGE_Binaire
	Return $str & StringTrimLeft(DllStructGetData($sImageBuffer, 1), 2)
EndFunc

Func DimentionsImage($Image)
	Local $Shutdown = False
	Local $hImage = _GDIPlus_ImageLoadFromFile($Image)
	Local $Taille = DimentionshImage($hImage)
	_GDIPlus_ImageDispose($hImage)
	Return $Taille
EndFunc

Func DimentionshImage($hImage)
	Local $Taille[2]
	$Taille[0] = _GDIPlus_ImageGetWidth($hImage)
	$Taille[1] = _GDIPlus_ImageGetHeight($hImage)
	Return $Taille
EndFunc

Func _ExitBitmap()
	_GDIPlus_Shutdown()
EndFunc