;~ This file is part of ClipKeeper.

;~     ClipKeeper is free software: you can redistribute it and/or modify
;~     it under the terms of the GNU General Public License as published by
;~     the Free Software Foundation, either version 3 of the License, or
;~     (at your option) any later version.

;~     ClipKeeper is distributed in the hope that it will be useful,
;~     but WITHOUT ANY WARRANTY; without even the implied warranty of
;~     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;~     GNU General Public License for more details.

;~     You should have received a copy of the GNU General Public License
;~     along with ClipKeeper.  If not, see <http://www.gnu.org/licenses/>.
Global $SurveillerSouris[10]

Func SurveillerSouris_Start()
	$SurveillerSouris[0] = 0
	AdlibRegister("SurveillerSouris", 20)
EndFunc

Func SurveillerSouris_Stop()
	AdlibUnRegister("SurveillerSouris")
EndFunc

Func SurveillerSouris_SetFunc($Func)
	$SurveillerSouris[9] = $Func
EndFunc

Func SurveillerSouris()
	Switch $SurveillerSouris[0]
		Case 0
			Local $mPos = MouseGetPos()
			$SurveillerSouris[1] = $mPos[0]
			$SurveillerSouris[2] = $mPos[1]
			$SurveillerSouris[0] += 1
		Case 1
			Local $mPos[2] = [$SurveillerSouris[1], $SurveillerSouris[2]]
			Local $mPos2 = MouseGetPos()
			$SurveillerSouris[3] = $mPos[0]
			$SurveillerSouris[4] = $mPos[1]
			If(_ArrayIsDifferent($mPos, $mPos2)) Then
				$SurveillerSouris[0] += 1
			EndIf
		Case 2
			Local $mPos2[2] = [$SurveillerSouris[3], $SurveillerSouris[4]]
			Local $mPos3 = MouseGetPos()
			If(Not(_ArrayIsDifferent($mPos2, $mPos3))) Then
				$SurveillerSouris[7] = $SurveillerSouris[5] - $SurveillerSouris[1]
				$SurveillerSouris[8] = $SurveillerSouris[6] - $SurveillerSouris[2]
				$SurveillerSouris[0] = 0
				Call($SurveillerSouris[9], $SurveillerSouris[7], $SurveillerSouris[8])
			EndIf
			$SurveillerSouris[5] = $mPos3[0]
			$SurveillerSouris[6] = $mPos3[1]
			$SurveillerSouris[3] = $SurveillerSouris[5]
			$SurveillerSouris[4] = $SurveillerSouris[6]
	EndSwitch
EndFunc

Func _ArrayIsDifferent($Arr1, $Arr2)
	Local $Retour = False
	Local $NbDim[2] = [UBound($Arr1, 0), UBound($Arr2, 0)]
	If($NbDim[0] = $NbDim[1] And $NbDim[0] > 0 And $NbDim[0] < 4) Then
		Switch $NbDim[0]
			Case 1
				Local $NbDim1[2] = [UBound($Arr1, 1), UBound($Arr2, 1)]
				If($NbDim1[0] = $NbDim1[1]) Then
					For $i = 0 To $NbDim1[0]-1
						If($Arr1[$i] <> $Arr2[$i]) Then
							$Retour = True
						EndIf
					Next
				EndIf
			Case 2
				Local $NbDim1[2] = [UBound($Arr1, 1), UBound($Arr2, 1)]
				Local $NbDim2[2] = [UBound($Arr1, 2), UBound($Arr2, 2)]
				If($NbDim1[0] = $NbDim1[1] And $NbDim2[0] = $NbDim2[1]) Then
					For $j = 0 To $NbDim1[0]-1
						For $i = 0 To $NbDim2[0]-1
							If($Arr1[$j][$i] <> $Arr2[$j][$i]) Then
								$Retour = True
							EndIf
						Next
					Next
				EndIf
			Case 3
				Local $NbDim1[2] = [UBound($Arr1, 1), UBound($Arr2, 1)]
				Local $NbDim2[2] = [UBound($Arr1, 2), UBound($Arr2, 2)]
				Local $NbDim3[2] = [UBound($Arr1, 3), UBound($Arr2, 3)]
				If($NbDim1[0] = $NbDim1[1] And $NbDim2[0] = $NbDim2[1] And $NbDim3[0] = $NbDim3[1]) Then
					For $k = 0 To $NbDim1[0]-1
						For $j = 0 To $NbDim2[0]-1
							For $i = 0 To $NbDim3[0]-1
								If($Arr1[$k][$j][$i] <> $Arr2[$k][$j][$i]) Then
									$Retour = True
								EndIf
							Next
						Next
					Next
				EndIf
		EndSwitch
	EndIf
	Return $Retour
EndFunc