#include-once
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <StructureConstants.au3>
#include <WinAPI.au3>
#include <WinAPIInternals.au3>
#include <WindowsConstants.au3>
#include "_ArrayEx.au3"
#include "_GUIRegisterMsg.au3"

Enum $_SETITEMCOLOR_HWND, $_SETITEMCOLOR_ID, $_SETITEMCOLOR_SUBITEM, $_SETITEMCOLOR_COLOR, $_SETITEMCOLOR_BKCOLOR, $_SETITEMCOLOR_MAX
Global $_SetItemColor[0][$_SETITEMCOLOR_MAX]

_GUIRegisterMsg($WM_NOTIFY, "_Func_SetItemColor")

Func _GUICtrlListView_SetItemColor($hwnd, $lvIndex, $subItem = -1, $color = Null, $bkColor = Null, $invalidate = True)
	If(Not(IsHWnd($hwnd))) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $lvId = _GUICtrlListView_MapIndexToID($hwnd, $lvIndex)
	Local $index = __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, $subItem)
	If($subItem = -1 Or $index < 0) Then
		Local $indiceParent = __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, -1)
		$color = ($color = Null) ? (($subItem >= 0) ? Default : Null) : (($color = Default) ? (($indiceParent >= 0 And $index < 0) ? $_SetItemColor[$indiceParent][$_SETITEMCOLOR_COLOR] : Default) : ColorConvert($color))
		$bkColor = ($bkColor = Null) ? (($subItem >= 0) ? Default : Null) : (($bkColor = Default) ? (($indiceParent >= 0 And $index < 0) ? $_SetItemColor[$indiceParent][$_SETITEMCOLOR_COLOR] : Default) : ColorConvert($bkColor))
		If($subItem = -1) Then
			Local $array = _Array_FindAllDouble($_SetItemColor, $hwnd, $_SETITEMCOLOR_HWND, $lvId, $_SETITEMCOLOR_ID)
			For $i = 0 To UBound($array, 1)-1
				If($color <> Default) Then $_SetItemColor[$array[$i]][$_SETITEMCOLOR_COLOR] = Default
				If($bkColor <> Default) Then $_SetItemColor[$array[$i]][$_SETITEMCOLOR_BKCOLOR] = Default
			Next
		EndIf
		Local $temp = [$hwnd, $lvId, $subItem, $color, $bkColor]
		_Array_Add($_SetItemColor, $temp)
	Else
		If($color <> Default) Then $_SetItemColor[$index][$_SETITEMCOLOR_COLOR] = ($color = Null) ? Null : ColorConvert($color)
		If($bkColor <> Default) Then $_SetItemColor[$index][$_SETITEMCOLOR_BKCOLOR] = ($bkColor = Null) ? Null : ColorConvert($bkColor)
		Local $array = _Array_ExtractSubArray($_SetItemColor, $index)
		_Array_Delete($_SetItemColor, $index)
		If($subItem = -1 And $array[$_SETITEMCOLOR_COLOR] <> Default And $array[$_SETITEMCOLOR_BKCOLOR] <> Default) Then
			_Array_DeleteByDoubleValues($_SetItemColor, $hwnd, $_SETITEMCOLOR_HWND, $lvId, $_SETITEMCOLOR_ID)
		EndIf
		_Array_Add($_SetItemColor, $array)
	EndIf
	If($invalidate) Then
		If($subItem = -1) Then
			Local $arrayRect = _GUICtrlListView_GetItemRect($hwnd, $lvIndex)
			Local $rect = _WinAPI_CreateRect($arrayRect[0], $arrayRect[1], $arrayRect[2], $arrayRect[3])
			_WinAPI_InvalidateRect($hwnd, $rect)
		Else
			Local $arrayRect = _GUICtrlListView_GetSubItemRect($hwnd, $lvIndex, $subItem)
			Local $rect = _WinAPI_CreateRect($arrayRect[0], $arrayRect[1], $arrayRect[2], $arrayRect[3])
			_WinAPI_InvalidateRect($hwnd, $rect)
		EndIf
	EndIf
	__SetItemColor_DeleteUseless()
	_array_display($_SetItemColor)
EndFunc

Func __SetItemColor_DeleteUseless()
	_Array_DeleteByDoubleValues($_SetItemColor, Default, $_SETITEMCOLOR_COLOR, Default, $_SETITEMCOLOR_BKCOLOR)
	_Array_DeleteByDoubleValues($_SetItemColor, Null, $_SETITEMCOLOR_COLOR, Null, $_SETITEMCOLOR_BKCOLOR)
	For $i = UBound($_SetItemColor, 1)-1 To 0 Step -1
		If(_GUICtrlListView_MapIDToIndex($_SetItemColor[$i][$_SETITEMCOLOR_HWND], $_SetItemColor[$i][$_SETITEMCOLOR_ID]) = -1) Then
			_Array_Delete($_SetItemColor, $i)
		EndIf
	Next
EndFunc

Func __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, $subItem)
	Return _Array_FindTriple2D($_SetItemColor, $hwnd, $_SETITEMCOLOR_HWND, $lvId, $_SETITEMCOLOR_ID, $subItem, $_SETITEMCOLOR_SUBITEM)
EndFunc

Func _Func_SetItemColor($hWnd, $iMsg, $wParam, $lParam)
	Local $tNMHDR, $hWndFrom, $iCode
	Local $return = $GUI_RUNDEFMSG
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iCode = DllStructGetData($tNMHDR, "Code")
	Local $processed = _Array_ExtractAll2D($_SetItemColor, $hWndFrom, $_SETITEMCOLOR_HWND)
	If(UBound($processed, 1) > 0) Then
		For $i = 0 To UBound($processed, 1)-1
			Switch $iCode
				Case $NM_CUSTOMDRAW
					Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
					Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
					ConsoleWrite($dwDrawStage & ", " & BitOR( $CDDS_ITEMPREPAINT, $CDDS_SUBITEM ) & @LF)
					Switch $dwDrawStage															; Holds a value that specifies the drawing stage
						Case $CDDS_PREPAINT														; Before the paint cycle begins
							Return $CDRF_NOTIFYITEMDRAW											; Notify the parent window of any item-related drawing operations
						Case $CDDS_ITEMPREPAINT													; Before painting an item
							Return $CDRF_NOTIFYSUBITEMDRAW										; Notify the parent window of any subitem-related drawing operations
						Case BitOR( $CDDS_ITEMPREPAINT, $CDDS_SUBITEM )							; Before painting a subitem
							Local $iSubItem = DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem")	; Subitem index
							Local $index = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")		; Item index
							Local $id = _GUICtrlListView_MapIndexToID($hWndFrom, $index)
							ConsoleWrite($index & ", " & $id & ", " & $iSubItem & @LF)
							If($id = $processed[$i][$_SETITEMCOLOR_ID] And ($processed[$i][$_SETITEMCOLOR_SUBITEM] = -1 Or $iSubItem = $processed[$i][$_SETITEMCOLOR_SUBITEM])) Then
								If($processed[$i][$_SETITEMCOLOR_COLOR] = Null) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", 0x000000)
								ElseIf($processed[$i][$_SETITEMCOLOR_COLOR] <> Default) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", $processed[$i][$_SETITEMCOLOR_COLOR])
								EndIf
								If($processed[$i][$_SETITEMCOLOR_BKCOLOR] = Null) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF)
								ElseIf($processed[$i][$_SETITEMCOLOR_BKCOLOR] <> Default) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", $processed[$i][$_SETITEMCOLOR_BKCOLOR])
								EndIf
								$return = $CDRF_NEWFONT											; $CDRF_NEWFONT must be returned after changing font or colors
							ElseIf($i = UBound($processed, 1)-1 And $return <> $CDRF_NEWFONT) Then
								DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", 0x000000)			; Forecolor of subitem text
								DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF)		; Backcolor of subitem text
								$return = $CDRF_NEWFONT											; $CDRF_NEWFONT must be returned after changing font or colors
							EndIf
					EndSwitch
			EndSwitch
		Next
	EndIf
	Return $return
EndFunc

Func ColorConvert($iColor)
	Return "0x" & Hex(BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16)), 6)
EndFunc
