;~ This file is part of ClipKeeper.

;~     ClipKeeper is free software: you can redistribute it and/or modify
;~     it under the terms of the GNU General Public License as published by
;~     the Free Software Foundation, either version 3 of the License, or
;~     (at your option) any later version.

;~     ClipKeeper is distributed in the hope that it will be useful,
;~     but WITHOUT ANY WARRANTY; without even the implied warranty of
;~     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;~     GNU General Public License for more details.

;~     You should have received a copy of the GNU General Public License
;~     along with ClipKeeper.  If not, see <http://www.gnu.org/licenses/>.
#include-once
#include <GUIConstantsEx.au3>

Dim $UDF_GUIRegisterMsg[1][2]
Dim $UDF_ListeRegisters[1]


; #FUNCTION# ====================================================================================================
; Name...........:	_GUIRegisterMsg
; Description....:	Ajoute une fonction  l'association d'un message
; Syntax.........:	_GUIRegisterMsg($Msg, $Fonction)
; Parameters.....:	$Msg 		- Un message window ($WM_XXXXX)
;
;					$Fonction 		- Le nom de la fonction associe
;
; Return values..:	Aucune
; Author.........:	TommyDDR (http://tombarthelemy.fr)
; Modified.......:
; Remarks........:	1) Les fonctions bloquantes sont  prohib dans la $Fonction, celle ci doit se terminer les plus rapidement possible.
; Related........:
; Link...........:
; Example........:
; ===============================================================================================================
Func _GUIRegisterMsg($Msg, $Fonction)
	;Si la fonction n'a pas encore t register pour le message donn
	If(__GUIRegisterGetRegister($Msg, $Fonction) = -1) Then
		;On ajoute la fonction et le message dans la liste
		__GUIRegisterAddMsg($Msg)
		Local $NumeroRegister = UBound($UDF_GUIRegisterMsg, 1)-1
		$UDF_GUIRegisterMsg[$NumeroRegister][0] = $Msg
		$UDF_GUIRegisterMsg[$NumeroRegister][1] = $Fonction
		ReDim $UDF_GUIRegisterMsg[UBound($UDF_GUIRegisterMsg, 1)+1][UBound($UDF_GUIRegisterMsg, 2)]
	EndIf
EndFunc

Func _GUIUnRegisterMsg($Msg, $Fonction)
	Local $Numero = __GUIRegisterGetRegister($Msg, $Fonction)
	; Si la fonction associe au message existe
	If($Numero >= 0) Then
		; On la supprime de la liste
		__GUIRegisterDelRegister($Numero)
	EndIf
EndFunc

Func __GUIRegisterAddMsg($Msg)
	Local $IDMsg = -1
	; On cherche si le message  dj t register
	For $i = 0 To UBound($UDF_ListeRegisters, 1)-2
		If($UDF_ListeRegisters[$i] = $Msg) Then
			$IDMsg = $i
			ExitLoop
		EndIf
	Next
	; Si le message n'a pas encore t register
	If($IDMsg = -1) Then
		$UDF_ListeRegisters[UBound($UDF_ListeRegisters, 1)-1] = $Msg
		GUIRegisterMsg($Msg, "__Func_GUIRegisterMsg")
	EndIf
EndFunc

Func __Func_GUIRegisterMsg($hWnd, $Msg, $wParam, $lParam)
	Local $Return = $GUI_RUNDEFMSG
	Local $ReturnBis
;~ 	ConsoleWrite($hWnd & ", " & $Msg & ", " & $wParam & ", " & $lParam & @CRLF)
	For $i = 0 To UBound($UDF_GUIRegisterMsg, 1)-2
		If($UDF_GUIRegisterMsg[$i][0] = $Msg) Then
			$ReturnBis = Call($UDF_GUIRegisterMsg[$i][1], $hWnd, $Msg, $wParam, $lParam)
			If($ReturnBis <> -1) Then
				$Return = $ReturnBis
			EndIf
		EndIf
	Next
	Return $Return
EndFunc

Func __GUIRegisterGetRegister($Msg, $Fonction)
	Local $Retour = -1
	For $i = 0 To UBound($UDF_GUIRegisterMsg, 1)-2
		If($UDF_GUIRegisterMsg[$i][0] = $Msg And $UDF_GUIRegisterMsg[$i][1] = $Fonction) Then
			$Retour = $i
			ExitLoop
		EndIf
	Next
	Return $Retour
EndFunc

Func __GUIRegisterDelRegister($Numero)
	For $i = $Numero To UBound($UDF_GUIRegisterMsg, 1)-3
		$UDF_GUIRegisterMsg[$i][0] = $UDF_GUIRegisterMsg[$i+1][0]
		$UDF_GUIRegisterMsg[$i][1] = $UDF_GUIRegisterMsg[$i+1][1]
	Next
	ReDim $UDF_GUIRegisterMsg[UBound($UDF_GUIRegisterMsg, 1)-1][UBound($UDF_GUIRegisterMsg, 2)]
EndFunc
