#include-once
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiTreeView.au3>
#include <ListViewConstants.au3>
#include <SendMessage.au3>
#include <StructureConstants.au3>
#include <WinAPI.au3>
#include <WinAPISys.au3>
#include <WinAPITheme.au3>
#include <WindowsConstants.au3>
#include "_ArrayEx.au3"
#include "_GUIRegisterMsg.au3"

Enum $XVIEW_ITEMCOLOR_HWND, $XVIEW_ITEMCOLOR_ID, $XVIEW_ITEMCOLOR_SUBITEM, $XVIEW_ITEMCOLOR_COLOR, $XVIEW_ITEMCOLOR_BKCOLOR, $XVIEW_ITEMCOLOR_MAX
Global $xView_ItemColor[0][$xView_ItemColor_MAX]
Global $xView_Items[0][3]
Global $xView_NoDrag[0]
Global $xView_NoDot[0]
Global $xView_Sorted[0]

_GUIRegisterMsg($WM_NOTIFY, "_Func_SetItemColor")

OnAutoItExitRegister("_exit_GUIXView")

;===============================================================================
; Nom:								  _GUICtrlXView_EnableDrag()
; Description:						  Active / dsactive l'affichage du petit "+" lors d'un drag&drop sur un lment de la listview
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$enable			: Position du graphique dans la fenetre (abssices)
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_EnableDrag($hwnd, $enable = True)
	If(Not(IsHWnd($hwnd))) Then
		$hwnd = GUICtrlGetHandle($hwnd)
	EndIf
	Local $id = _Array_Find1D($xView_NoDrag, $hwnd)
	If($id >= 0) Then
		If($enable) Then
			_Array_Delete($xView_NoDrag, $id)
		EndIf
	Else
		If(Not($enable)) Then
			_Array_Add($xView_NoDrag, $hwnd)
		EndIf
	EndIf
EndFunc

;===============================================================================
; Nom:								  _GUICtrlXView_SetOnEvent()
; Description:						  Associe un venement fait sur une (list/tree)view  une fonction
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$func			: Fonction appelle lors de la dtection de l'venement (Doit tre de la forme : Func foncion($hwnd, $event)
;					$event			: venement  surveiller
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlXView_SetOnEvent($hwnd, $func, $event)
	If($func = "") Then
		_GUICtrlXView_UnsetOnEvent($hwnd, $func, $event)
	EndIf
	If(Not(IsHWnd($hWnd))) Then
		$hwnd = GUICtrlGetHandle($hwnd)
	EndIf
	If($hwnd = 0) Then
		Return SetError(1, 0, False)
	EndIf
	Local $index = __XView_GetItemsByHwndAndFunc($hwnd, $func)
	Local $tabEvent[1] = [$event]
	If($index = -1) Then
		_Array_Add($xView_Items, _Asarray($hwnd, $func, $tabEvent))
		If(UBound($xView_Items, 1)-1 = 0) Then
			_GUIRegisterMsg($WM_NOTIFY, "__Func_XViewNotify")
		EndIf
	Else
		$tabEvent = $xView_Items[$index][2]
		If(_Array_Find1D($tabEvent, $event) = -1) Then
			ReDim $tabEvent[UBound($tabEvent, 1)+1]
			$tabEvent[UBound($tabEvent, 1)-1] = $event
			$xView_Items[$index][2] = $tabEvent
		EndIf
		ReDim $xView_Items[UBound($xView_Items, 1)+1][UBound($xView_Items, 2)]
	EndIf
EndFunc

;===============================================================================
; Nom:								  _GUICtrlXView_UnsetOnEvent()
; Description:						  Annule un _GUICtrlXView_SetOnEvent()
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$func			: Fonction qui tait appelle lors de la dtection de l'venement
;					$event			: venement  ne plus surveiller
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlXView_UnsetOnEvent($hwnd, $func, $event)
	If(Not(IsHWnd($hWnd))) Then
		$hwnd = GUICtrlGetHandle($hwnd)
	EndIf
	If($hwnd = 0) Then
		Return SetError(1, 0, False)
	EndIf
	Local $index = __XView_GetItemsByHwndAndEvent($hwnd, $event)
	If($index >= 0) Then
		Local $tabEvent = $xView_Items[$index][2]
		Local $indice = _Array_Find1D($tabEvent, $event)
		_Array_Delete($tabEvent, $indice)
		$xView_Items[$index][2] = $tabEvent
	EndIf
EndFunc

;===============================================================================
; Nom:								  _GUICtrlListView_GetSelectedIndice()
; Description:						  Retourne le 1er lment slectionn
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$func			: Fonction qui tait appelle lors de la dtection de l'venement
;					$event			: venement  ne plus surveiller
;
; Retour :			succes			: Le 1er lment slectionn
;					fail			: -1
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_GetSelectedIndice($hWnd, $fArray = False)
	Local $indice = -1
	Local $indices = _GUICtrlListView_GetSelectedIndices($hWnd, True)
	Local $array[2] = [1, 0]
	Local $retour
	If($indices[0] > 0) Then
		$indice = $indices[1]
	EndIf
	$retour = $indice
	If($fArray) Then
		$array[1] = $indice
		$retour = $array
	EndIf
	Return $retour
EndFunc

Func __Func_XViewNotify($hWnd, $msg, $wParam, $lParam)
	Local $tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	Local $iEvent = DllStructGetData($tNMHDR, "Code")
	Local $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	Local $cible = __XView_GetItemsByHwnd($hWndFrom)
	If(UBound($cible, 1) > 0) Then
		For $i = 0 To UBound($cible, 1)-1
			Local $tabEvent = $xView_Items[$cible[$i]][2]
			For $j = 0 To UBound($tabEvent, 1)-1
				If($iEvent = $tabEvent[$j]) Then
;~ 					ConsoleWrite($iCode & " = " & $tabEvent[$j] & @CRLF)
					Call($xView_Items[$cible[$i]][1], $hWndFrom, $iEvent)
				EndIf
			Next
		Next
	EndIf
	$cible = _Array_Find1D($xView_NoDrag, $hWndFrom)
	If($iEvent = $LVN_BEGINDRAG And $cible >= 0) Then
		Return 1
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc

Func __Func_RemoveDot($hwnd, $msg, $wParam, $lParam)
	Local $hiWord = _WinAPI_HiWord($wParam)
	Local $loWord = _WinAPI_LoWord($wParam)
	If(BitAND($hiWord, 0x1) And $loWord = 2) Then Return 1
EndFunc

Func __XView_GetItemsByHwndAndEvent($hwnd, $event)
	Local $retour = -1
	For $i = 0 To UBound($xView_Items, 1)-1
		If($xView_Items[$i][0] = $hwnd) Then
			Local $tabEvent = $xView_Items[$i][2]
			For $j = 0 To UBound($tabEvent, 1)-1
				If($tabEvent[$j] = $event) Then
					$retour = $i
					ExitLoop 2
				EndIf
			Next
		EndIf
	Next
	Return $retour
EndFunc

Func __XView_GetItemsByHwndAndFunc($hwnd, $func)
	Local $retour = -1
	For $i = 0 To UBound($xView_Items, 1)-1
		If($xView_Items[$i][0] = $hwnd And $xView_Items[$i][1] = $func) Then
			$retour = $i
			ExitLoop
		EndIf
	Next
	Return $retour
EndFunc

Func __XView_GetItemsByHwnd($hwnd)
	Local $retour[0]
	For $i = 0 To UBound($xView_Items, 1)-1
		If($xView_Items[$i][0] = $hwnd) Then
			_Array_Add($retour, $i)
		EndIf
	Next
	Return $retour
EndFunc

;===============================================================================
; Nom:								  _GUICtrlListView_ExtractColumn()
; Description:						  Extrait les textes d'une colone d'une liste d'index d'items
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$items			: La liste des index  extraire ou (-1 : tous les items / -2 : items selectionns)
;
; Retour :			succes			: les textes de la colone de la liste d'index d'items
;					fail			: Un tableau vide
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_ExtractColumn($listView, $column, $indices = -2)
	If(Not(IsArray($indices))) Then
		Local $array[1]
		Switch $indices
			Case -2
				$array = _GUICtrlListView_GetSelectedIndices($listView, True)
				_Array_Delete($array, 0)
			Case -1
				ReDim $array[_GUICtrlListView_GetItemCount($listView)]
				For $i = 0 To UBound($array, 1)-1
					$array[$i] = $i
				Next
			Case Else
				$array[0] = Number($indices)
		EndSwitch
		$indices = $array
	EndIf
	Local $retour[0]
	For $i = 0 To UBound($indices, 1)-1
		_Array_Add($retour, _GUICtrlListView_GetItemText($listView, $indices[$i], $column))
	Next
	Return $retour
EndFunc
;===============================================================================
; Nom:								  _GUICtrlListView_Find()
; Description:						  Retourne les indexes dont le texte de la colonne $colonne correspond  $search
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$search			: Texte  rechercher
;					$colonne		: Numro de la colonne  rechercher
;
; Retour :			succes			: les indexes correspondant  la recherche
;					fail			: Un tableau vide
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_Find($hwnd, $search = "", $column = 0)
	Local $retour[0]
	Local $iMax = _GUICtrlListView_GetItemCount($hwnd)-1
	For $i = 0 To $iMax
		If(_GUICtrlListView_GetItemText($hwnd, $i, $column) = $search) Then
			_Array_Add($retour, $i)
		EndIf
	Next
	Return $retour
EndFunc

;===============================================================================
; Nom:								  _GUICtrlListView_GetIndexByColumns()
; Description:						  Retourne les indexes dont les textes des colonnes $colonne et $colonne2 correspondent  $search et $search2
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;					$search			: Texte 1  rechercher
;					$colonne		: Numro de la colonne 1  rechercher
;					$search2		: Texte 2  rechercher
;					$colonne2		: Numro de la colonne 2  rechercher
;
; Retour :			succes			: les indexes correspondant  la recherche
;					fail			: Un tableau vide
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_GetIndexByColumns($lView, $search = -1, $colonne = 0, $search2 = -1, $colonne2 = 0)
	Local $retour[0]
	Local $count = _GUICtrlListView_GetItemCount($lView)
	If($count > 0) Then
		Local $itemText
		Local $itemText2
		For $i = 0 To $count
			$itemText = _GUICtrlListView_GetItemText($lView, $i, $colonne)
			$itemText2 = _GUICtrlListView_GetItemText($lView, $i, $colonne2)
			If(($itemText = $search Or $search = -1) And ($itemText2 = $search2 Or $search2 = -1)) Then
				_Array_Add($retour, $i)
			EndIf
		Next
	EndIf
	Return $retour
EndFunc

;===============================================================================
; Nom:								  _GUICtrlListView_GetSelectedIDs()
; Description:						  Retourne les IDs (et non pas les indexes) slectionns
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;
; Retour :			succes			: Le handle du premier parent de l'item
;					fail			: Un tableau vide
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListView_GetSelectedIDs($lView)
	Local $retour = _GUICtrlListView_GetSelectedIndices($lView, True)
	_Array_Delete($retour, 0)
	For $i = 0 To UBound($retour, 1)-1
		$retour[$i] = _GUICtrlListView_MapIndexToID($lView, $retour[$i])
	Next
	Return $retour
EndFunc

;===============================================================================
; Nom:								  _GUICtrlListViewEx_DeleteAllItems()
; Description:						  Supprime tous les items d'une listview (avec begin et end update)
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la listView
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlListViewEx_DeleteAllItems($lView)
	_GUICtrlListView_BeginUpdate($lView)
	For $i = 0 To _GUICtrlListView_GetItemCount($lView)-1
		_GUICtrlListView_DeleteItem($lView, 0)
	Next
	_GUICtrlListView_EndUpdate($lView)
EndFunc

;===============================================================================
; Nom:								  _GUICtrlTreeView_GetAllParentsText()
; Description:						  Retourne une chaine de caractre contenant les textes des treeviewitems spar par $separator
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la treeview
;					$hItem			: Handle (ou CtrlId) de l'item
;					$separator		: Sparateur  utiliser
;
; Retour :			succes			: Chaine contenant les textes des treeviewitems spar par $separator
;					fail			: ""
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlTreeView_GetAllParentsText($hwnd, $hItem, $separator, $first = True)
	Local $search = ""
	Local $hParent = _GUICtrlTreeView_GetParentHandle($hwnd, $hItem)
	If($hParent <> False) Then
		$search = _GUICtrlTreeView_GetAllParentsText($hwnd, $hParent, $separator, False)
	EndIf
	Return $search & _GUICtrlTreeView_GetText($hwnd, $hItem) & (($first) ? "" : $separator)
EndFunc

;===============================================================================
; Nom:								  _GUICtrlTreeView_GetItemUnderMouse()
; Description:						  Retourne le handle de l'item sous la souris
; Paramtres:    	$hwnd			: Handle de la treeview
;
; Retour :			succes			: Le handle de l'item sous la souris
;					fail			: 0
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlTreeView_GetItemUnderMouse($hwnd)
	Local $tPoint = _WinAPI_GetMousePos(True, $hwnd)
	Local $mX = DllStructGetData($tPoint, "X")
	Local $mY = DllStructGetData($tPoint, "Y")
	Return _GUICtrlTreeView_HitTestItem($hwnd, $mX, $mY)
EndFunc

;===============================================================================
; Nom:								  _GUICtrlTreeView_GetFirstParent()
; Description:						  Retourne le handle premier parent (racine) d'un item
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la treeview
;					$hItem			: Item dont on cherche le parent
;
; Retour :			succes			: Le handle du premier parent de l'item
;					fail			: $hItem
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlTreeView_GetFirstParent($hwnd, $hItem)
	Local $firstParent = $hItem
	While(True)
		Local $hParent = _GUICtrlTreeView_GetParentHandle($hwnd, $firstParent)
		If($hParent = 0) Then ExitLoop
		$firstParent = $hParent
	WEnd
	Return $firstParent
EndFunc

;===============================================================================
; Nom:								  _GUICtrlTreeView_ExpandIfNot()
; Description:						  Dplie / Replie un treeview item seulement si celui-ci ne l'est pas dj
; Paramtres:    	$hwnd			: Handle (ou CtrlId) de la treeview
;					$hItem			: Item que l'on veut dplier/replier
;					$expand			: True : Dplier
;									  False : Replier
;
; Retour :			succes			: Le handle du premier parent de l'item
;					fail			: $hItem
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUICtrlTreeView_ExpandIfNot($hwnd, $hItem, $expand = True)
	If(_GUICtrlTreeView_GetExpanded($hwnd, $hItem) <> $expand) Then
		_GUICtrlTreeView_Expand($hwnd, $hItem, $expand)
	EndIf
EndFunc


Func _GUICtrlListView_DeselectItems($hwnd, $start = 0, $end = -1)
	If($end = -1) Then $end = _GUICtrlListView_GetItemCount($hwnd)-1
	For $i = $start To $end
		_GUICtrlListView_SetItemSelected($hwnd, $i, False)
	Next
EndFunc

Func _GUICtrlListView_CopyToClipboard($hwnd, $delim1 = @TAB, $delim2 = @CRLF)
	Local $clip = ""
	Local $iMax = _GUICtrlListView_GetItemCount($hwnd)-1
	Local $jMax = _GUICtrlListView_GetColumnCount($hwnd)-1
	For $i = 0 To $iMax
		For $j = 0 To $jMax
			$clip &= _GUICtrlListView_GetItemText($hwnd, $i, $j) & $delim1
		Next
		$clip = StringTrimRight($clip, StringLen($delim1)) & $delim2
	Next
	$clip = StringTrimRight($clip, StringLen($delim2))
	ClipPut($clip)
EndFunc

Func _GUICtrlXView_SetConf($hwnd, $sorted = True, $disableDrag = True)
	If($hwnd > 0) Then
		_GUICtrlXView_SetExplorerTheme($hwnd)
		_GUICtrlListView_SetExtendedListViewStyle($hwnd, BitOR($lVS_EX_DOUBLEBUFFER, $lVS_EX_FULLROWSELECT, $lVS_EX_SUBITEMIMAGES, $LVS_EX_HEADERDRAGDROP))
		If($sorted) Then
			_GUICtrlListView_SetSorted($hwnd)
		EndIf
		If($disableDrag) Then
			_GUICtrlListView_EnableDrag($hwnd, False)
		EndIf
	EndIf
EndFunc

Func _GUICtrlXView_RemoveDots($hwnd, $remove = True)
	If(Not(IsHWnd($hwnd))) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $indice = _Array_Find1D($xView_NoDot, $hwnd)
	If($indice = -1) Then
		If($remove) Then
			If(UBound($xView_NoDot, 1) = 0) Then
				_GUIRegisterMsg($WM_CHANGEUISTATE, "__Func_RemoveDot")
			EndIf
			_Array_Add($xView_NoDot, $hwnd)
			_SendMessage($hwnd, 0x127, 0x10001, 0)
		EndIf
	Else
		If(Not($remove)) Then
			_Array_Delete($xView_NoDot, $indice)
			If(UBound($xView_NoDot, 1) = 0) Then
				_GUIUnregisterMsg($WM_CHANGEUISTATE, "__Func_RemoveDot")
			EndIf
			_SendMessage($hwnd, 0x127, 0x10002, 0)
		EndIf
	EndIf
EndFunc

Func _GUICtrlXView_SetExplorerTheme($hwnd)
	If _WinAPI_GetVersion() >= '6.0' Then
		If(Not(IsHWnd($hwnd))) Then $hwnd = GUICtrlGetHandle($hwnd)
		_WinAPI_SetWindowTheme($hwnd, 'Explorer')
	EndIf
EndFunc

Func _GUICtrlListView_SetSorted($lView, $sorted = True)
	Local $index = _Array_Find1D($xView_Sorted, $lView)
	If($sorted And $index < 0) Then
		_Array_Add($xView_Sorted, $lView)
		GUICtrlSetOnEvent($lView, "__ListView_SortItems")
		_GUICtrlListView_RegisterSortCallBack($lView)
	ElseIf(Not($sorted) And $index >= 0) Then
		_GUICtrlListView_UnRegisterSortCallBack($xView_Sorted[$index])
		_Array_Delete($xView_Sorted, $index)
	EndIf
EndFunc

Func __ListView_SortItems()
	Local $index = -1
	For $i = 0 To UBound($xView_Sorted, 1)-1
		If($xView_Sorted[$i] = @GUI_CtrlId) Then
			_GUICtrlListView_SortItems($xView_Sorted[$i], GUICtrlGetState($xView_Sorted[$i]))
			ExitLoop
		EndIf
	Next
EndFunc

Func _GUICtrlListView_RemoveAllColors($hwnd)
	If(Not(IsHWnd($hwnd))) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $processed = _Array_FindAll($xView_ItemColor, $hwnd, $xView_ItemColor_HWND)
	_array_display($processed)
	For $i = UBound($processed, 1)-1 To 0 Step -1
		_Array_Delete($xView_ItemColor, $processed[$i])
	Next
	_WinAPI_RedrawWindow($hwnd)
EndFunc

Func _GUICtrlListView_SetItemColor($hwnd, $lvIndex, $subItem = -1, $color = Null, $bkColor = Null, $invalidate = True)
	If(Not(IsHWnd($hwnd))) Then $hwnd = GUICtrlGetHandle($hwnd)
	Local $lvId = _GUICtrlListView_MapIndexToID($hwnd, $lvIndex)
	Local $index = __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, $subItem)
	If($subItem = -1 Or $index < 0) Then
		Local $indiceParent = __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, -1)
		$color = ($color = Null) ? (($subItem >= 0) ? Default : Null) : (($color = Default) ? (($indiceParent >= 0 And $index < 0) ? $xView_ItemColor[$indiceParent][$xView_ItemColor_COLOR] : Default) : ColorConvert($color))
		$bkColor = ($bkColor = Null) ? (($subItem >= 0) ? Default : Null) : (($bkColor = Default) ? (($indiceParent >= 0 And $index < 0) ? $xView_ItemColor[$indiceParent][$xView_ItemColor_COLOR] : Default) : ColorConvert($bkColor))
		If($subItem = -1) Then
			Local $array = _Array_FindAllDouble($xView_ItemColor, $hwnd, $xView_ItemColor_HWND, $lvId, $xView_ItemColor_ID)
			For $i = 0 To UBound($array, 1)-1
				If($color <> Default) Then $xView_ItemColor[$array[$i]][$xView_ItemColor_COLOR] = Default
				If($bkColor <> Default) Then $xView_ItemColor[$array[$i]][$xView_ItemColor_BKCOLOR] = Default
			Next
		EndIf
		Local $temp = [$hwnd, $lvId, $subItem, $color, $bkColor]
		_Array_Add($xView_ItemColor, $temp)
	Else
		If($color <> Default) Then $xView_ItemColor[$index][$xView_ItemColor_COLOR] = ($color = Null) ? Null : ColorConvert($color)
		If($bkColor <> Default) Then $xView_ItemColor[$index][$xView_ItemColor_BKCOLOR] = ($bkColor = Null) ? Null : ColorConvert($bkColor)
		Local $array = _Array_ExtractSubArray($xView_ItemColor, $index)
		_Array_Delete($xView_ItemColor, $index)
		If($subItem = -1 And $array[$xView_ItemColor_COLOR] <> Default And $array[$xView_ItemColor_BKCOLOR] <> Default) Then
			_Array_DeleteByDoubleValues($xView_ItemColor, $hwnd, $xView_ItemColor_HWND, $lvId, $xView_ItemColor_ID)
		EndIf
		_Array_Add($xView_ItemColor, $array)
	EndIf
	If($invalidate) Then
		Local $arrayRect
		If($subItem = -1) Then
			$arrayRect = _GUICtrlListView_GetItemRect($hwnd, $lvIndex)
			Local $rect = _WinAPI_CreateRect($arrayRect[0], $arrayRect[1], $arrayRect[2], $arrayRect[3])
			_WinAPI_InvalidateRect($hwnd, $rect)
		Else
			$arrayRect = _GUICtrlListView_GetSubItemRect($hwnd, $lvIndex, $subItem)
			Local $rect = _WinAPI_CreateRect($arrayRect[0], $arrayRect[1], $arrayRect[2], $arrayRect[3])
			_WinAPI_InvalidateRect($hwnd, $rect)
		EndIf
	EndIf
	__SetItemColor_DeleteUseless()
;~ 	_array_display($xView_ItemColor)
EndFunc

Func __SetItemColor_DeleteUseless()
	_Array_DeleteByDoubleValues($xView_ItemColor, Default, $xView_ItemColor_COLOR, Default, $xView_ItemColor_BKCOLOR)
	_Array_DeleteByDoubleValues($xView_ItemColor, Null, $xView_ItemColor_COLOR, Null, $xView_ItemColor_BKCOLOR)
	For $i = UBound($xView_ItemColor, 1)-1 To 0 Step -1
		If(_GUICtrlListView_MapIDToIndex($xView_ItemColor[$i][$xView_ItemColor_HWND], $xView_ItemColor[$i][$xView_ItemColor_ID]) = -1) Then
			_Array_Delete($xView_ItemColor, $i)
		EndIf
	Next
EndFunc

Func __GetIndexByHwndAndIndexAndSubItem($hwnd, $lvId, $subItem)
	Return _Array_FindTriple2D($xView_ItemColor, $hwnd, $xView_ItemColor_HWND, $lvId, $xView_ItemColor_ID, $subItem, $xView_ItemColor_SUBITEM)
EndFunc

Func _Func_SetItemColor($hWnd, $iMsg, $wParam, $lParam)
	Local $tNMHDR, $hWndFrom, $iCode
	Local $return = $GUI_RUNDEFMSG
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iCode = DllStructGetData($tNMHDR, "Code")
	Local $processed = _Array_ExtractAll2D($xView_ItemColor, $hWndFrom, $xView_ItemColor_HWND)
	For $i = 0 To UBound($processed, 1)-1
		If(BitAND(WinGetState($processed[$i][$XVIEW_ITEMCOLOR_HWND]), 4) = 4) Then
			Switch $iCode
				Case $NM_CUSTOMDRAW
					Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
					Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
					Switch $dwDrawStage															; Holds a value that specifies the drawing stage
						Case $CDDS_PREPAINT														; Before the paint cycle begins
							$return = $CDRF_NOTIFYITEMDRAW										; Notify the parent window of any item-related drawing operations
						Case $CDDS_ITEMPREPAINT													; Before painting an item
							$return = $CDRF_NOTIFYSUBITEMDRAW									; Notify the parent window of any subitem-related drawing operations
						Case BitOR( $CDDS_ITEMPREPAINT, $CDDS_SUBITEM )							; Before painting a subitem
							Local $iSubItem = DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem")	; Subitem index
							Local $index = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")		; Item index
							Local $id = _GUICtrlListView_MapIndexToID($hWndFrom, $index)
							If($id = $processed[$i][$xView_ItemColor_ID] And ($processed[$i][$xView_ItemColor_SUBITEM] = -1 Or $iSubItem = $processed[$i][$xView_ItemColor_SUBITEM])) Then
								If($processed[$i][$xView_ItemColor_COLOR] = Null) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", 0x000000)
								ElseIf($processed[$i][$xView_ItemColor_COLOR] <> Default) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", $processed[$i][$xView_ItemColor_COLOR])
								EndIf
								If($processed[$i][$xView_ItemColor_BKCOLOR] = Null) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF)
								ElseIf($processed[$i][$xView_ItemColor_BKCOLOR] <> Default) Then
									DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", $processed[$i][$xView_ItemColor_BKCOLOR])
								EndIf
								$return = $CDRF_NEWFONT											; $CDRF_NEWFONT must be returned after changing font or colors
							ElseIf($i = UBound($processed, 1)-1 And $return <> $CDRF_NEWFONT) Then
								DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", 0x000000)			; Forecolor of subitem text
								DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF)		; Backcolor of subitem text
								$return = $CDRF_NEWFONT											; $CDRF_NEWFONT must be returned after changing font or colors
							EndIf
					EndSwitch
			EndSwitch
		EndIf
	Next
	Return $return
EndFunc

Func ColorConvert($iColor)
	Return "0x" & Hex(BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16)), 6)
EndFunc

Func _exit_GUIXView()
	For $i = 0 To UBound($xView_Sorted, 1)-1
		_GUICtrlListView_UnRegisterSortCallBack($xView_Sorted[$i])
	Next
EndFunc