#include-once
#include <APIGdiConstants.au3>
#include <WinAPI.au3>
#include <WinAPIGdi.au3>

Global Const $tag_POINTL =				"long x;long y"
Global Const $tag_DEVMOD =				"wchar dmDeviceName[32];ushort dmSpecVersion;ushort dmDriverVersion;short dmSize;" & _
										"ushort dmDriverExtra;dword dmFields;" & $tag_POINTL & ";dword dmDisplayOrientation;dword dmDisplayFixedOutput;" & _
										"short dmColor;short dmDuplex;short dmYResolution;short dmTTOption;short dmCollate;" & _
										"wchar dmFormName[32];ushort dmLogPixels;dword dmBitsPerPel;int dmPelsWidth;dword dmPelsHeight;" & _
										"dword dmDisplayFlags;dword dmDisplayFrequency"


Func GetDesktopSize()
	Local $retour[4] = [0, 0, 0, 0]
	For $i = 0 To _MonitorGetCount()-1
		Local $temp = _MonitorGetCurrentSettings($i)
		If($temp[6] < $retour[0]) Then $retour[0] = $temp[6]
		If($temp[7] < $retour[1]) Then $retour[1] = $temp[7]
		If($temp[6]+$temp[0] > $retour[2]) Then $retour[2] = $temp[6]+$temp[0]
		If($temp[7]+$temp[1] > $retour[3]) Then $retour[3] = $temp[7]+$temp[1]
	Next
	$retour[2] -= $retour[0]
	$retour[3] -= $retour[1]
	Return $retour
EndFunc

Func _MonitorGetCount()
	Local $monitors = _WinAPI_EnumDisplayMonitors()
	Return $monitors[0][0]
EndFunc

Func _MonitorGetCurrentSettings($number)
	Local $retour[8]
	Local $displayName = _MonitorGetDisplayName($number)
	Local $DEVMODE = DllStructCreate($tag_DEVMOD)
	Local $B = DllCall('user32.dll', 'bool', 'EnumDisplaySettingsW', "wstr", $displayName, 'dword', $ENUM_CURRENT_SETTINGS, 'struct*', DllStructGetPtr($DEVMODE))
	If(@error) Then Return SetError(@error, "", $retour)
	$retour[0] = DllStructGetData($DEVMODE, "dmPelsWidth")
	$retour[1] = DllStructGetData($DEVMODE, "dmPelsHeight")
	$retour[2] = DllStructGetData($DEVMODE, "dmBitsPerPel")
	$retour[3] = DllStructGetData($DEVMODE, "dmDisplayFrequency")
	$retour[4] = DllStructGetData($DEVMODE, "dmDisplayOrientation")
	$retour[5] = DllStructGetData($DEVMODE, "dmDisplayFixedOutput")
	$retour[6] = DllStructGetData($DEVMODE, "x")
	$retour[7] = DllStructGetData($DEVMODE, "y")
	Return $retour
EndFunc

Func _MonitorGetDisplayName($number)
	Local $retour = ""
	Local $displayDevice = _WinAPI_EnumDisplayDevices("", $number)
	If(IsArray($displayDevice)) Then
		$retour = $displayDevice[1]
	EndIf
	Return $retour
EndFunc
